;;; jdunnet.el --- Text adventure for Emacs(Japanese version)
;; Modified by HAKASE <hakase2772@yahoo.co.jp>, Since 9/30, 2006
;; Version: 2.01jp-0.04a

;; ̃vORon Schnell̍쐬eLXgAhx`[Q[
;; dunnet Ver 2.01 ̃bZ[W{ꉻňꕔĝłB
;; ̃Q[emacsñGfB^œ삵܂B
;; F{ł͂܂łłB|󂵂ĂȂbZ[WcĂ܂B
;;     ̃vO|Ɋւ鎿Ron Schnellɂ͑Ȃ
;;     łB

;; jdunnet  쌠 IWi dunnet Ɠl GPL ɏ܂B
;; ȉɃIWĩvÕwb_܂B
;; --------------------------------------------------------------------------
;;; dunnet.el --- Text adventure for Emacs

;; Copyright (C) 1992, 1993 Free Software Foundation, Inc.

;; Author: Ron Schnell <ronnie@driver-aces.com>
;; Created: 25 Jul 1992
;; Version: 2.01
;; Keywords: games

;; This file is part of GNU Emacs.

;; GNU Emacs is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; GNU Emacs is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to the
;; Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;; Commentary:

;; This game can be run in batch mode.  To do this, use:
;;    emacs -batch -l dunnet
;; --------------------------------------------------------------------------

;;; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
;;;  The log file should be set for your system, and it must
;;;  be writable by all.
;;   KvȂAXRÃOt@CȂ̃VXȅ󋵂ɉ
;;   āASẴ[U\ɂĂB

(defgroup dunnet nil
  "Text adventure for Emacs."
  :prefix "dun-"
  :group 'games)

(defcustom dun-log-file "/usr/local/dunnet.score"
  "Name of file to store score information for dunnet."
  :type 'file
  :group 'dunnet)

(if nil
    (eval-and-compile (setq byte-compile-warnings nil)))

(eval-when-compile
 (require 'cl))

;;;; Mode definitions for interactive mode

(defun dun-mode ()
  "Major mode for running dunnet."
  (interactive)
  (text-mode)
  (make-local-variable 'scroll-step)
  (setq scroll-step 2)
  (use-local-map dungeon-mode-map)
  (setq major-mode 'dungeon-mode)
  (setq mode-name "Dungeon"))

(defun dun-parse (arg)
  "Function called when return is pressed in interactive mode to parse line."
  (interactive "*p")
  (beginning-of-line)
  (setq beg (+ (point) 1))
  (end-of-line)
  (if (and (not (= beg (point))) (not (< (point) beg))
	   (string= ">" (buffer-substring (- beg 1) beg)))
      (progn
	(setq line (downcase (buffer-substring beg (point))))
	(princ line)
	(if (eq (dun-vparse dun-ignore dun-verblist line) -1)
	    (dun-mprinc "͗ł܂B\n")))
    (goto-char (point-max))
    (dun-mprinc "\n"))
    (dun-messages))
    
(defun dun-messages ()
  (if dun-dead
      (text-mode)
    (if (eq dungeon-mode 'dungeon)
	(progn
	  (if (not (= room dun-current-room))
	      (progn
		(dun-describe-room dun-current-room)
		(setq room dun-current-room)))
	  (dun-fix-screen)
	  (dun-mprinc ">")))))


;;;###autoload
(defun jdunnet ()
  "Switch to *dungeon* buffer and start game."
  (interactive)
  (switch-to-buffer "*dungeon*")
  (dun-mode)
  (setq dun-dead nil)
  (setq room 0)
  (dun-messages))

;;;;
;;;; This section contains all of the verbs and commands.
;;;;

;;; Give long description of room if haven't been there yet.  Otherwise
;;; short.  Also give long if we were called with negative room number.

(defun dun-describe-room (room)
  (if (and (not (member (abs room) dun-light-rooms)) 
	   (not (member obj-lamp dun-inventory)))
      (dun-mprincl "͐^ÂłB̂܂܂ł̓O[ɐH\łB")
;    (dun-mprincl (cadr (nth (abs room) dun-rooms)))
    (dun-mprinc "ꏊF ")
    (dun-mprinc (caddr (nth (abs room) dun-rooms)))
    (dun-mprincl (format " <%s>" (cadr (nth (abs room) dun-rooms))))
    (if (and (and (or (member room dun-visited) 
		      (string= dun-mode "dun-superb")) (> room 0))
	     (not (string= dun-mode "long")))
	nil
      (dun-mprinc (car (nth (abs room) dun-rooms)))
    (dun-mprinc "\n"))
    (if (not (string= dun-mode "long"))
	(if (not (member (abs room) dun-visited))
	    (setq dun-visited (append (list (abs room)) dun-visited))))
    (dolist (xobjs (nth dun-current-room dun-room-objects))
      (if (= xobjs obj-special)
	  (dun-special-object)
	(if (>= xobjs 0)
	    (dun-mprincl (car (nth xobjs dun-objects)))
	  (if (not (and (= xobjs obj-bus) dun-inbus))
	      (progn
		(dun-mprincl (car (nth (abs xobjs) dun-perm-objects)))))))
      (if (and (= xobjs obj-jar) dun-jar)
	  (progn
	    (dun-mprincl "т̒gF")
	    (dolist (x dun-jar)
	      (dun-mprinc "     ")
	      (dun-mprincl (car (nth x dun-objects)))))))
    (if (and (member obj-bus (nth dun-current-room dun-room-objects)) dun-inbus)
	(dun-mprincl "Ȃ̓oX(bus)ɏĂ܂B"))))

;;; There is a special object in the room.  This object's description,
;;; or lack thereof, depends on certain conditions.

(defun dun-special-object ()
  (if (= dun-current-room computer-room)
      (if dun-computer
	  (dun-mprincl 
"pl̃Cg͑gDꂽp^[`̂悤ɓ_łĂ܂B")
	(dun-mprincl "pl̃Cg͕ς炸~Ă܂B")))

  (if (and (= dun-current-room red-room) 
	   (not (member obj-towel (nth red-room dun-room-objects))))
      (dun-mprincl "̏ɂ͌(hole)Ă܂B"))

  (if (and (= dun-current-room marine-life-area) dun-black)
      (dun-mprincl 
"̓ubNCgŏƂ炳Ă܂BƁAĂȂ̎
̌ɂĕsCɋPĂ܂B"))
  (if (and (= dun-current-room fourth-vermont-intersection) dun-hole)
      (progn
	(if (not dun-inbus)
	    (progn
	      (dun-mprincl"Ȃ͒nʂ̌ւƗ܂B")
	      (setq dun-current-room vermont-station)
	      (dun-describe-room vermont-station))
	  (progn
	    (dun-mprincl 
"oX͒nʂɊJւƗAĔ܂B")
	    (dun-die "burning")))))

  (if (> dun-current-room endgame-computer-room)
      (progn
	(if (not dun-correct-answer)
	    (dun-endgame-question)
    (dun-mprincl "Ȃւ͎̎̒ʂłF")
    (dun-mprincl (cdr (assoc dun-question-message dun-endgame-questions-msg)))
;	  (dun-mprincl "Your question is:")
;	  (dun-mprincl dun-endgame-question)
)))

  (if (= dun-current-room sauna)
      (progn
	(dun-mprincl (nth dun-sauna-level '(
"̎x͕ʂłB"
"͂ȂܒgłB"
"͉KȏłB"
"͍܂ŊƂ̂ȂłB"
"Ȃ͍ł܂B")))
	(if (= dun-sauna-level 3) 
	    (progn
	      (if (or (member obj-rms dun-inventory)
		      (member obj-rms (nth dun-current-room dun-room-objects)))
		  (progn
		    (dun-mprincl 
"Ȃ͂Ȃ̎Ăl`Ƃ͂߂āAĊSɂƂ
܂̂ɋC܂BāÂƂɂ́A_CAh
(diamond)c܂I")
		    (if (member obj-rms dun-inventory)
			(progn
			  (dun-remove-obj-from-inven obj-rms)
			  (setq dun-inventory (append dun-inventory 
						      (list obj-diamond))))
		      (dun-remove-obj-from-room dun-current-room obj-rms)
		      (dun-replace dun-room-objects dun-current-room
				   (append (nth dun-current-room dun-room-objects)
					   (list obj-diamond))))))
	      (if (or (member obj-floppy dun-inventory)
		      (member obj-floppy (nth dun-current-room dun-room-objects)))
		  (progn
		    (dun-mprincl
"Ȃ͂Ȃ̎Ătbs[fBXNn͂߂Ă̂
C܂BȂɂƂƁAĔRoAł
܂܂B")
		    (dun-remove-obj-from-inven obj-floppy)
		    (dun-remove-obj-from-room dun-current-room obj-floppy))))))))


(defun dun-die (murderer)
  (dun-mprinc "\n")
  (if murderer
      (dun-mprincl "Ȃ͎ł܂܂B\nf`ld nudq"))
  (dun-do-logfile 'dun-die murderer)
  (dun-score nil)
  (setq dun-dead t))

(defun dun-quit (args)
  (dun-die nil))

;;; Print every object in player's inventory.  Special case for the jar,
;;; as we must also print what is in it.

(defun dun-inven (args)
  (dun-mprinc "Ȃ͎̂̂Ă܂:")
  (dun-mprinc "\n")
  (dolist (curobj dun-inventory)
    (if curobj
	(progn
	  (dun-mprincl (cadr (nth curobj dun-objects)))
	  (if (and (= curobj obj-jar) dun-jar)
	      (progn
		(dun-mprincl "KXт(jar)Ɋ܂܂:")
		(dolist (x dun-jar)
		  (dun-mprinc "     ")
		  (dun-mprincl (cadr (nth x dun-objects))))))))))

(defun dun-shake (obj)
  (let (objnum)
    (when (setq objnum (dun-objnum-from-args-std obj))
      (if (member objnum dun-inventory)
	  (progn
;;;	If shaking anything will do anything, put here.
;	    (dun-mprinc "Shaking ")
;	    (dun-mprinc (downcase (cadr (nth objnum dun-objects))))
;	    (dun-mprinc " seems to have no effect.")
;	    (dun-mprinc "\n")
	    (dun-mprinc (format "Ȃ %s ӂ܂B\nNȂ悤ɂ݂܂B\n"
              (downcase (cadr (nth objnum dun-objects)))))
	    )
	(if (and (not (member objnum (nth dun-current-room dun-room-silents)))
		 (not (member objnum (nth dun-current-room dun-room-objects))))
	    (dun-mprincl "͂ɂ͌܂B")
;;;     Shaking trees can be deadly
	  (if (= objnum obj-tree)
	      (progn
		(dun-mprinc
 "Ȃ؂UƁA󂩂烄V̎n߂̂ɋC܂B
Ȃ͂邽߂Ɏɏグ悤Ƃ܂ȂOɂȂ
ꂪ̏ɗՌ܂B")
		(dun-die "a coconut"))
	    (if (= objnum obj-bear)
		(progn
		  (dun-mprinc
"Ȃ͌F̂Ƃɋ߂ÂƁAF͂Ȃ̓苎āA
Ȃ̓͒nɗ܂B")
		  (dun-die "a bear"))
	      (if (< objnum 0)
		  (dun-mprincl "ӂ邱Ƃ͂ł܂B")
		(dun-mprincl "Ȃ͂Ă܂B")))))))))


(defun dun-drop (obj)
  (if dun-inbus
      (dun-mprincl "oX̒ł͉uƂ͂ł܂B")
  (let (objnum ptr)
    (when (setq objnum (dun-objnum-from-args-std obj))
      (if (not (setq ptr (member objnum dun-inventory)))
	  (dun-mprincl "Ȃ͂Ă܂B")
	(progn
	  (dun-remove-obj-from-inven objnum)
	  (dun-replace dun-room-objects dun-current-room
		   (append (nth dun-current-room dun-room-objects)
			   (list objnum)))
	  (dun-mprincl "u܂B")
	  (if (member objnum (list obj-food obj-weight obj-jar))
	      (dun-drop-check objnum))))))))

;;; Dropping certain things causes things to happen.

(defun dun-drop-check (objnum)
  (if (and (= objnum obj-food) (= room bear-hangout)
	   (member obj-bear (nth bear-hangout dun-room-objects)))
      (progn
	(dun-mprincl
"F͐HוЂāA܂Bނ͉𗎂Ƃ
悤łB")
	(dun-remove-obj-from-room dun-current-room obj-bear)
	(dun-remove-obj-from-room dun-current-room obj-food)
	(dun-replace dun-room-objects dun-current-room
		 (append (nth dun-current-room dun-room-objects)
			 (list obj-key)))))

  (if (and (= objnum obj-jar) (member obj-nitric dun-jar) 
	   (member obj-glycerine dun-jar))
      (progn
	(dun-mprincl 
	 "т񂪒nʂɂԂƁA͕Xɍӂ܂B")
	(setq dun-jar nil)
	(dun-remove-obj-from-room dun-current-room obj-jar)
	(if (= dun-current-room fourth-vermont-intersection)
	    (progn
	      (setq dun-hole t)
	      (setq dun-current-room vermont-station)
	      (dun-mprincl 
"
NAnʂɌ܂BȂ͂̌ɗ܂B")))))

  (if (and (= objnum obj-weight) (= dun-current-room maze-button-room))
      (dun-mprincl "ʘHJ܂B")))

;;; Give long description of current room, or an object.
      
(defun dun-examine (obj)
  (let (objnum)
    (setq objnum (dun-objnum-from-args obj))
    (if (eq objnum obj-special)
	(dun-describe-room (* dun-current-room -1))
      (if (and (eq objnum obj-computer)
	       (member obj-pc (nth dun-current-room dun-room-silents)))
	  (dun-examine '("pc"))
	(if (eq objnum nil)
	    (dun-mprincl "ꂪ킩܂B")
	  (if (and (not (member objnum 
				(nth dun-current-room dun-room-objects)))
		   (not (and (member obj-jar dun-inventory)
			     (member objnum dun-jar)))
		   (not (member objnum 
				(nth dun-current-room dun-room-silents)))
		   (not (member objnum dun-inventory)))
	      (dun-mprincl "͂ɂ͌܂B")
	    (if (>= objnum 0)
		(if (and (= objnum obj-bone) 
			 (= dun-current-room marine-life-area) dun-black)
		    (dun-mprincl 
"̌ɂāAȂ͍̏ɏꂽǂނƂł܂B
ɂ͎̂悤ɏĂ܂B
  u鎞ɂ́ASʂƃo[gʂ̌_֍sBv")
		  (if (nth objnum dun-physobj-desc)
		      (dun-mprincl (nth objnum dun-physobj-desc))
		    (dun-mprincl "Ɍׂ̂͂܂B")))
	      (if (nth (abs objnum) dun-permobj-desc)
		  (progn
		    (dun-mprincl (nth (abs objnum) dun-permobj-desc)))
		(dun-mprincl "Ɍׂ̂͂܂B")))))))))

(defun dun-take (obj)
    (setq obj (dun-firstword obj))
    (if (not obj)
	(dun-mprincl "邩𓮎 take ̌Ɏw肵ĂB")
      (if (string= obj "all")
	  (let (gotsome)
	    (if dun-inbus
		(dun-mprincl "oX(bus)ɏĂԂ͉܂B")
	      (setq gotsome nil)
	      (dolist (x (nth dun-current-room dun-room-objects))
		(if (and (>= x 0) (not (= x obj-special)))
		    (progn
		      (setq gotsome t)
		      (dun-mprinc (cadr (nth x dun-objects)))
		      (dun-mprinc ": ")
		      (dun-take-object x))))
	      (if (not gotsome)
		  (dun-mprincl "ׂ̂͂܂B"))))
	(let (objnum)
	  (setq objnum (cdr (assq (intern obj) dun-objnames)))
	  (if (eq objnum nil)
	      (progn
		(dun-mprinc "ꂪ킩܂B")
		(dun-mprinc "\n"))
	    (if (and dun-inbus (not (and (member objnum dun-jar)
					 (member obj-jar dun-inventory))))
		(dun-mprincl "oX(bus)ɏĂԂ͉܂B")
	      (dun-take-object objnum)))))))

(defun dun-take-object (objnum)
  (if (and (member objnum dun-jar) (member obj-jar dun-inventory))
      (let (newjar)
	(dun-mprincl "Ȃ͂т񂩂炻菜܂B")
	(setq newjar nil)
	(dolist (x dun-jar)
	  (if (not (= x objnum))
	      (setq newjar (append newjar (list x)))))
	(setq dun-jar newjar)
	(setq dun-inventory (append dun-inventory (list objnum))))
    (if (not (member objnum (nth dun-current-room dun-room-objects)))
	(if (not (member objnum (nth dun-current-room dun-room-silents)))
	    (dun-mprinc "͂ɂ͌܂B")
	  (dun-try-take objnum))
      (if (>= objnum 0)
	  (progn
	    (if (and (car dun-inventory) 
		     (> (+ (dun-inven-weight) (nth objnum dun-object-lbs)) 11))
		(dun-mprinc "Ȃ̉ו͏d܂B")
	      (setq dun-inventory (append dun-inventory (list objnum)))
	      (dun-remove-obj-from-room dun-current-room objnum)
	      (dun-mprinc "܂B ")
	      (if (and (= objnum obj-towel) (= dun-current-room red-room))
		  (dun-mprinc 
		   "^IƁAɌĂ邱Ƃ킩܂B"))))
	(dun-try-take objnum)))
    (dun-mprinc "\n")))

(defun dun-inven-weight ()
  (let (total)
    (setq total 0)
    (dolist (x dun-jar)
      (setq total (+ total (nth x dun-object-lbs))))
    (dolist (x dun-inventory)
      (setq total (+ total (nth x dun-object-lbs)))) total))

;;; We try to take an object that is untakable.  Print a message
;;; depending on what it is.

(defun dun-try-take (obj)
  (dun-mprinc "邱Ƃ͂ł܂B"))

(defun dun-dig (args)
  (if dun-inbus
      (dun-mprincl "Ō@Ă݂܂B")
  (if (not (member 0 dun-inventory))
      (dun-mprincl "Ȃ͌@邽߂̓Ă܂B")
    (if (not (nth dun-current-room dun-diggables))
	(dun-mprincl "Ō@Ă݂܂B")
      (dun-mprincl "@ƉoĂ܂B")
      (dun-replace dun-room-objects dun-current-room
	       (append (nth dun-current-room dun-room-objects)
		       (nth dun-current-room dun-diggables)))
      (dun-replace dun-diggables dun-current-room nil)))))

(defun dun-climb (obj)
  (let (objnum)
    (setq objnum (dun-objnum-from-args obj))
    (cond ((not objnum)
	   (dun-mprincl "ꂪ킩܂B"))
	  ((and (not (eq objnum obj-special))
		(not (member objnum (nth dun-current-room dun-room-objects)))
		(not (member objnum (nth dun-current-room dun-room-silents)))
		(not (and (member objnum dun-jar) (member obj-jar dun-inventory)))
		(not (member objnum dun-inventory)))
	   (dun-mprincl "͂ɂ͌܂B"))
	  ((and (eq objnum obj-special)
		(not (member obj-tree (nth dun-current-room dun-room-silents))))
	   (dun-mprincl "ɂ͓ô͉܂B"))
	  ((and (not (eq objnum obj-tree)) (not (eq objnum obj-special)))
	   (dun-mprincl "Ȃ͂ɓo邱Ƃ͂ł܂B"))
	  (t
	   (dun-mprincl
	    "Ȃ͂QtB[gقǖ؂oAč~܂B
Ȃ͖؂ƂĂ炮炵Ă邱ƂɋCÂ܂B")))))

(defun dun-eat (obj)
  (let (objnum)
    (when (setq objnum (dun-objnum-from-args-std obj))
      (if (not (member objnum dun-inventory))
	  (dun-mprincl "Ă܂B")
	(if (not (= objnum obj-food))
	    (progn
	      (dun-mprinc "Ȃ ")
	      (dun-mprinc (downcase (cadr (nth objnum dun-objects))))
	      (dun-mprincl " Aɂ߂ނƁAȂ͒͂߂܂B")
	      (dun-die "choking"))
	  (dun-mprincl "͋낵܂B")
	  (dun-remove-obj-from-inven obj-food))))))

(defun dun-put (args)
    (let (newargs objnum objnum2 obj)
      (setq newargs (dun-firstwordl args))
      (if (not newargs)
	  (dun-mprincl "ړIw肵ĂB")
	(setq obj (intern (car newargs)))
	(setq objnum (cdr (assq obj dun-objnames)))
	(if (not objnum)
	    (dun-mprincl "ꂪ킩܂B")
	  (if (not (member objnum dun-inventory))
	      (dun-mprincl "Ȃ͂Ă܂B")
	    (setq newargs (dun-firstwordl (cdr newargs)))
	    (setq newargs (dun-firstwordl (cdr newargs)))
	    (if (not newargs)
		(dun-mprincl "Ώۂw肵Ăiput A in B ȂǁjB")
	      (setq objnum2 (cdr (assq (intern (car newargs)) dun-objnames)))
	      (if (and (eq objnum2 obj-computer) (= dun-current-room pc-area))
		  (setq objnum2 obj-pc))
	      (if (not objnum2)
		  (dun-mprincl "w肳ꂽΏۂ킩܂B")
		(if (and (not (member objnum2 
				      (nth dun-current-room dun-room-objects)))
			 (not (member objnum2 
				      (nth dun-current-room dun-room-silents)))
			 (not (member objnum2 dun-inventory)))
		    (dun-mprincl "w肳ꂽΏۂ͂ɂ͂܂B")
		  (dun-put-objs objnum objnum2)))))))))

(defun dun-put-objs (obj1 obj2)
  (if (and (= obj2 obj-drop) (not dun-nomail))
      (setq obj2 obj-chute))

  (if (= obj2 obj-disposal) (setq obj2 obj-chute))

  (if (and (= obj1 obj-cpu) (= obj2 obj-computer))
      (progn
	(dun-remove-obj-from-inven obj-cpu)
	(setq dun-computer t)
	(dun-mprincl
"ȂRs[^CPU{[hƁA͂ɉғ܂B
_ł͂߁At@͂߂܂B"))
    (if (and (= obj1 obj-weight) (= obj2 obj-button))
	(dun-drop '("weight"))
      (if (= obj2 obj-jar)                 ;; Put something in jar
	  (if (not (member obj1 (list obj-paper obj-diamond obj-emerald
				      obj-license obj-coins obj-egg
				      obj-nitric obj-glycerine)))
	      (dun-mprincl "͂тɓɂ͓K܂B")
	    (dun-remove-obj-from-inven obj1)
	    (setq dun-jar (append dun-jar (list obj1)))
	    (dun-mprincl "܂"))
	(if (= obj2 obj-chute)                 ;; Put something in chute
	    (progn
	      (dun-remove-obj-from-inven obj1)
	      (dun-mprincl 
"Ȃ𒆂ɂׂƁAꂪւ𕷂܂B")
	      (dun-put-objs-in-treas (list obj1)))
	  (if (= obj2 obj-box)              ;; Put key in key box
	      (if (= obj1 obj-key)
		  (progn
		    (dun-mprincl
"ȂƁA͐U͂߂܂BčŌɂ͔
܂܂B͂ȂȂĂ܂悤Ɍ܂I")
		    (dun-remove-obj-from-inven obj1)
		    (dun-replace dun-room-objects computer-room (append
							(nth computer-room
							     dun-room-objects)
							(list obj1)))
		    (dun-remove-obj-from-room dun-current-room obj-box)
		    (setq dun-key-level (1+ dun-key-level)))
		(dun-mprincl "L[{bNXɂ͂邱Ƃ͂ł܂I"))

	    (if (and (= obj1 obj-floppy) (= obj2 obj-pc))
		(progn
		  (setq dun-floppy t)
		  (dun-remove-obj-from-inven obj1)
		  (dun-mprincl "܂B"))

	      (if (= obj2 obj-urinal)                   ;; Put object in urinal
		  (progn
		    (dun-remove-obj-from-inven obj1)
		    (dun-replace dun-room-objects urinal (append 
						  (nth urinal dun-room-objects)
						   (list obj1)))
		    (dun-mprincl
		     "Ȃ͂ꂪɂ鐅̒ɗ鉹𕷂܂B"))
		(if (= obj2 obj-mail)
		    (dun-mprincl "X֎󂯂ɂ͌Ă܂B")
		  (if (member obj1 dun-inventory)
		      (dun-mprincl 
"ǂgݍ킹΂̂킩܂B
PɗƂ(drop)邱ƂĂ݂ĂB")
		    (dun-mprincl"Ȃ͂ɓ邱Ƃ͂ł܂B")))))))))))

(defun dun-type (args)
  (if (not (= dun-current-room computer-room))
      (dun-mprincl "Ȃ^Cvł̂͂ɂ͂܂B")
    (if (not dun-computer)
	(dun-mprincl 
"Ȃ̓L[{[h^Cv܂BAȂ̃^Cv
\炳܂łB")
      (dun-unix-interface))))

;;; Various movement directions

(defun dun-n (args)
  (dun-move north))

(defun dun-s (args)
  (dun-move south))

(defun dun-e (args)
  (dun-move east))

(defun dun-w (args)
  (dun-move west))

(defun dun-ne (args)
  (dun-move northeast))

(defun dun-se (args)
  (dun-move southeast))

(defun dun-nw (args)
  (dun-move northwest))

(defun dun-sw (args)
  (dun-move southwest))

(defun dun-up (args)
  (dun-move up))

(defun dun-down (args)
  (dun-move down))

(defun dun-in (args)
  (dun-move in))

(defun dun-out (args)
  (dun-move out))

(defun dun-go (args)
  (if (or (not (car args)) 
	  (eq (dun-doverb dun-ignore dun-verblist (car args) 
			  (cdr (cdr args))) -1))
      (dun-mprinc "ǂ֍s΂̂킩܂B\n")))

;;; Uses the dungeon-map to figure out where we are going.  If the
;;; requested direction yields 255, we know something special is
;;; supposed to happen, or perhaps you can't go that way unless
;;; certain conditions are met.

(defun dun-move (dir)
  (if (and (not (member dun-current-room dun-light-rooms)) 
	   (not (member obj-lamp dun-inventory)))
      (progn
	(dun-mprinc 
"Ȃ̓O[ɂ܂ÂČɗAĂȂ̑̂̑SĂ̍
O[ɍӂĂ܂܂B")
	(dun-die "a grue"))
    (let (newroom)
      (setq newroom (nth dir (nth dun-current-room dungeon-map)))
      (if (eq newroom -1)
	  (dun-mprinc "Ȃ͂̕֍sƂ͂ł܂B\n")
	(if (eq newroom 255)
	    (dun-special-move dir)
	  (setq room -1)
	  (setq dun-lastdir dir)
	  (if dun-inbus
	      (progn
		(if (or (< newroom 58) (> newroom 83))
		    (dun-mprincl "oX͂ւ͍s܂B")
		  (dun-mprincl 
		   "oX͋}ɑOɌXAċ}~܂B")
		  (dun-remove-obj-from-room dun-current-room obj-bus)
		  (setq dun-current-room newroom)
		  (dun-replace dun-room-objects newroom
			   (append (nth newroom dun-room-objects)
				   (list obj-bus)))))
	    (setq dun-current-room newroom)))))))

;;; Movement in this direction causes something special to happen if the
;;; right conditions exist.  It may be that you can't go this way unless
;;; you have a key, or a passage has been opened.

;;; coding note: Each check of the current room is on the same 'if' level,
;;; i.e. there aren't else's.  If two rooms next to each other have
;;; specials, and they are connected by specials, this could cause
;;; a problem.  Be careful when adding them to consider this, and
;;; perhaps use else's.

(defun dun-special-move (dir)
  (if (= dun-current-room building-front)
      (if (not (member obj-key dun-inventory))
	  (dun-mprincl "Ȃ̓hAJ邽߂̌Ă܂B")
	(setq dun-current-room old-building-hallway))
    (if (= dun-current-room north-end-of-cave-passage)
	(let (combo)
	  (dun-mprincl 
"Ȃ̕ɓɂ͂R̐^CvȂ΂Ȃ܂B")
	  (dun-mprinc " R̐́H : ")
	  (setq combo (dun-read-line))
	  (if (not dun-batch-mode)
	      (dun-mprinc "\n"))
	  (if (string= combo dun-combination)
	      (setq dun-current-room gamma-computing-center)
	    (dun-mprincl "̐̑gݍ킹͕słB"))))

    (if (= dun-current-room bear-hangout)
	(if (member obj-bear (nth bear-hangout dun-room-objects))
	    (progn
	      (dun-mprinc 
"ȂF̂΂ȂɕĒʂ߂悤ƂƂɁA
F͂ƂĂ՗悤łBނ́AȂ̓H邱Ƃ
Ȃɋ܂B")
	      (dun-die "a bear"))
	  (dun-mprincl "Ȃ͂̕ւ͍s܂B")))

    (if (= dun-current-room vermont-station)
	(progn
	  (dun-mprincl
"
ȂԂɏ荞ނƁA͂ɉwo܂BԂ͏㉺E
hASn͍ňłBȂ͏łɂy邽߂
֎q̂ЂƂɍ܂B")
	  (dun-mprincl
"\nŌɂ͗Ԃ͓ˑR~AhAJȀՌłȂ͊Oւ
o܂BāAԂ͑苎܂B\n")
	  (setq dun-current-room museum-station)))

    (if (= dun-current-room old-building-hallway)
	(if (and (member obj-key dun-inventory)
		 (> dun-key-level 0))
	    (setq dun-current-room meadow)
	  (dun-mprincl "Ȃ̓hAJ邽߂̌Ă܂B")))

    (if (and (= dun-current-room maze-button-room) (= dir northwest))
	(if (member obj-weight (nth maze-button-room dun-room-objects))
	    (setq dun-current-room 18)
	  (dun-mprincl "Ȃ͂֍sƂ͏o܂B")))

    (if (and (= dun-current-room maze-button-room) (= dir up))
	(if (member obj-weight (nth maze-button-room dun-room-objects))
	    (dun-mprincl "Ȃ͂֍sƂ͏o܂B")
	  (setq dun-current-room weight-room)))

    (if (= dun-current-room classroom)
	(dun-mprincl "hA̓bNĂ܂B"))

    (if (or (= dun-current-room lakefront-north) 
	    (= dun-current-room lakefront-south))
	(dun-swim nil))

    (if (= dun-current-room reception-area)
	(if (not (= dun-sauna-level 3))
	    (setq dun-current-room health-club-front)
	  (dun-mprincl
"Ȃo悤ƂƂÂЂƂ牊oĂ̂
Ct܂BˑRA͋ȉ΂̋ʂƂȂĔ܂B
Ȃ̑̂̂ݍ݁AȂ͏Ăł܂܂B")
	  (dun-die "burning")))

    (if (= dun-current-room red-room)
	(if (not (member obj-towel (nth red-room dun-room-objects)))
	    (setq dun-current-room long-n-s-hallway)
	  (dun-mprincl "Ȃ͂֍sƂ͏o܂B")))

    (if (and (> dir down) (> dun-current-room gamma-computing-center) 
	     (< dun-current-room museum-lobby))
	(if (not (member obj-bus (nth dun-current-room dun-room-objects)))
	    (dun-mprincl "Ȃ͂֍sƂ͏o܂B")
	  (if (= dir in)
	      (if dun-inbus
		  (dun-mprincl
		   "Ȃ͊ɃoX̒ɂ܂I")
		(if (member obj-license dun-inventory)
		    (progn
		      (dun-mprincl 
		       "Ȃ̓oXɏ荞݁A^]Ȃɓ܂B")
		      (setq dun-nomail t)
		      (setq dun-inbus t))
		  (dun-mprincl "Ȃ͂̎̏蕨^]邽߂̖Ƌ؂Ă܂B")))
	    (if (not dun-inbus)
		(dun-mprincl "Ȃ͊ɃoX~Ă܂I")
	      (dun-mprincl "Ȃ̓oXэ~܂B")
	      (setq dun-inbus nil))))
      (if (= dun-current-room fifth-oaktree-intersection)
	  (if (not dun-inbus)
	      (progn
		(dun-mprincl "Ȃ͊R̉ɂ܂ɗAnʂɂԂ܂B")
		(dun-die "a cliff"))
	    (dun-mprincl
"oX͊RւƔяoAR̒ւƓ˂݁AĔ܂B")
	    (dun-die "a bus accident")))
      (if (= dun-current-room main-maple-intersection)
	  (progn
	    (if (not dun-inbus)
		(dun-mprincl "͊JȂł傤B")
	      (dun-mprincl
"
oX߂ÂƖ傪JAȂ͂ʉ߂܂B")
	      (dun-remove-obj-from-room main-maple-intersection obj-bus)
	      (dun-replace dun-room-objects museum-entrance 
		       (append (nth museum-entrance dun-room-objects)
			       (list obj-bus)))
	      (setq dun-current-room museum-entrance)))))
    (if (= dun-current-room cave-entrance)
	(progn
	  (dun-mprincl
"
ȂɓƁA܂Ђт܂B
Ȃӂ肩ƁAV䂩狐Ȋ₪藎AȂ
ӂ̂܂B\n")
	  (setq dun-current-room misty-room)))))

(defun dun-long (args)
  (setq dun-mode "long"))

(defun dun-turn (obj)
  (let (objnum direction)
    (when (setq objnum (dun-objnum-from-args-std obj))
      (if (not (or (member objnum (nth dun-current-room dun-room-objects))
		   (member objnum (nth dun-current-room dun-room-silents))))
	  (dun-mprincl "͂ɂ͌܂B")
	(if (not (= objnum obj-dial))
	    (dun-mprincl "͉]ł܂B")
	  (setq direction (dun-firstword (cdr obj)))
	  (if (or (not direction) 
		  (not (or (string= direction "clockwise")
			   (string= direction "counterclockwise"))))
	      (dun-mprincl "߂ɑĎv(clockwise)v(counterclockwise)
w肵ĂBi turn A clockwisej")
	    (if (string= direction "clockwise")
		(setq dun-sauna-level (+ dun-sauna-level 1))
	      (setq dun-sauna-level (- dun-sauna-level 1)))
	    
	    (if (< dun-sauna-level 0)
		(progn
		  (dun-mprincl 
		   "_CA͂ȏセ̕։񂷂Ƃ͂łȂł傤B")
		  (setq dun-sauna-level 0))
	      (dun-sauna-heat))))))))

(defun dun-sauna-heat ()
  (if (= dun-sauna-level 0)
      (dun-mprincl 
       "x͕WIȎxɖ߂܂B"))
  (if (= dun-sauna-level 1)
      (dun-mprincl "CȂܒgȂ܂BȂ͊Ă܂B"))
  (if (= dun-sauna-level 2)
      (dun-mprincl "͍Ȃ菋łB܂ƂĂKłB"))
  (if (= dun-sauna-level 3)
      (progn
	(dun-mprincl 
"͍ƂĂȂłB̉xɂ͐܂ς悤ȉ܂B")
	(if (or (member obj-rms dun-inventory) 
		(member obj-rms (nth dun-current-room dun-room-objects)))
	    (progn
	      (dun-mprincl 
"Ȃ͂Ȃ̎Ăl`Ƃ͂߂āAĊSɂƂ
܂̂ɋC܂BāÂƂɂ́A_CAh
(diamond)c܂I")
	      (if (member obj-rms dun-inventory)
		  (progn
		    (dun-remove-obj-from-inven obj-rms)
		    (setq dun-inventory (append dun-inventory 
						(list obj-diamond))))
		(dun-remove-obj-from-room dun-current-room obj-rms)
		(dun-replace dun-room-objects dun-current-room
			 (append (nth dun-current-room dun-room-objects)
				 (list obj-diamond))))))
	(if (or (member obj-floppy dun-inventory)
		(member obj-floppy (nth dun-current-room dun-room-objects)))
	    (progn
	      (dun-mprincl
"Ȃ͂Ȃ̎Ătbs[fBXNn͂߂Ă̂
C܂BȂɂƂƁAĔRoAł
܂܂B")
	      (if (member obj-floppy dun-inventory)
		  (dun-remove-obj-from-inven obj-floppy)
		(dun-remove-obj-from-room dun-current-room obj-floppy))))))

  (if (= dun-sauna-level 4)
      (progn
	(dun-mprincl 
"_CȀꏊƁAȂ͓̑̂ˑRŔRオ܂B")
	(dun-die "burning"))))

(defun dun-press (obj)
  (let (objnum)
    (when (setq objnum (dun-objnum-from-args-std obj))
      (if (not (or (member objnum (nth dun-current-room dun-room-objects))
		   (member objnum (nth dun-current-room dun-room-silents))))
	  (dun-mprincl "͂ɂ͌܂B")
	(if (not (member objnum (list obj-button obj-switch)))
	    (progn
	      (dun-mprinc "You can't ")
	      (dun-mprinc (car line-list))
	      (dun-mprincl " that."))
	  (if (= objnum obj-button)
	      (dun-mprincl
"Ȃ{^ƁAʘHĴɋC܂B{^
ƁA̒ʘH͕Ă܂܂B"))
	  (if (= objnum obj-switch)
	      (if dun-black
		  (progn
		    (dun-mprincl "{^͍It̏ԂɂȂĂ܂B")
		    (setq dun-black nil))
		(dun-mprincl "{^͍ȈԂɂȂĂ܂B")
		(setq dun-black t))))))))

(defun dun-swim (args)
  (if (not (member dun-current-room (list lakefront-north lakefront-south)))
      (dun-mprincl "j悤Ȑ͌܂I")
    (if (not (member obj-life dun-inventory))
	(progn
	  (dun-mprincl 
"Ȃ͌΂ɔэ݁Ał͂߂Đɗ₽ƂɋCÂ܂B
āAȂA͂܂Ƃɂ͉jwłȂ񂾂ƌɂ
Ȃ͂̕X̂悤ȗ₽Ɋ͂߂Ă܂B")
	  (dun-die "drowning"))
      (if (= dun-current-room lakefront-north)
	  (setq dun-current-room lakefront-south)
	(setq dun-current-room lakefront-north)))))


(defun dun-score (args)
  (if (not dun-endgame)
      (let (total)
	(setq total (dun-reg-score))
	(dun-mprinc "Ȃ̍v_")
	(dun-mprinc total)
	(dun-mprincl "_łi擾\ȓ_90_łjB") total)
    (dun-mprinc "Ȃ̍v_")
    (dun-mprinc (dun-endgame-score))
    (dun-mprincl " _łiQ[NA̍ō_110_łjB")
    (if (= (dun-endgame-score) 110)
;    (if (= (dun-endgame-score) 90)
	(dun-mprincl 
"\n\n߂łƂBȂ͏܂B
The wizard password is 'moby'\n"))))

(defun dun-helpeng (args)
  (dun-mprincl
"Welcome to dunnet (2.01), by Ron Schnell (ronnie@driver-aces.com).
Here is some useful information (read carefully because there are one
or more clues in here):
- If you have a key that can open a door, you do not need to explicitly
  open it.  You may just use 'in' or walk in the direction of the door.

- If you have a lamp, it is always lit.

- You will not get any points until you manage to get treasures to a certain
  place.  Simply finding the treasures is not good enough.  There is more
  than one way to get a treasure to the special place.  It is also
  important that the objects get to the special place *unharmed* and
  *untarnished*.  You can tell if you have successfully transported the
  object by looking at your score, as it changes immediately.  Note that
  an object can become harmed even after you have received points for it.
  If this happens, your score will decrease, and in many cases you can never
  get credit for it again.

- You can save your game with the 'save' command, and use restore it
  with the 'restore' command.

- There are no limits on lengths of object names.

- Directions are: north,south,east,west,northeast,southeast,northwest,
                  southwest,up,down,in,out.

- These can be abbreviated: n,s,e,w,ne,se,nw,sw,u,d,in,out.

- If you go down a hole in the floor without an aid such as a ladder,
  you probably won't be able to get back up the way you came, if at all.

- To run this game in batch mode (no emacs window), use:
     emacs -batch -l dunnet
NOTE: This game *should* be run in batch mode!

If you have questions or comments, please contact ronnie@driver-aces.com
My home page is http://www.driver-aces.com/ronnie.html
"))

(defun dun-help (args)
  (dun-mprincl
"悤jdunnetցBRon Schnelldunnet(2.01){ꉻ
̂łBł͗Lvȏ񋟂܂iɂ͑̎肪肪
Ă̂ŁAӂēǂłBj

AhAJ邱ƂłL[(key)Ă΁AȂ
  hAJ铮͂Kv͂܂BȂ͒PɁuinv
  gAhÂ֕ŃhAɓ邱Ƃł܂B
ȂvĂ΁Ał_(lit)ł܂B

ȂꏊɎĂƂɐ܂ł́AȂ
  _𓾂邱Ƃł܂BPɕ邾ł͕s\łB
  ʂȏꏊ֎Ă@͂ЂƂł͂܂B
  ̃mu󂳂ɁvuɁvĂƂdvłB
  _͂ɕω̂ŁA score œ_΂Ȃm
  ړɐǂ܂B
  _𓾂Ãmꂽ肵Ȃ悤ɒӂĂB
  ꂪNΓ_AČ̓_ɖ߂邱Ƃ͂Ȃł傤B

Ȃ́AR}husavevŃQ[ꎞۑ邱Ƃł܂B
  āAR}hurestorevɂāAĊJ邱Ƃł܂B
IuWFNg̒ɂ͐܂B

ړ́Fk north,  south,  east,  west,k northeast , 
          쓌 southeast , k northwest, k southwest ,
           up,  down,  in , o out ,g܂B
 ̒Zk`ł͂ł܂B n,s,e,w,ne,se,nw,sw,u,d,in,out 

ȂnVŜ悤ȎxȂŏɂɉ肽Ȃ΁A
  炭Ȃ͏ɓo邱Ƃ͂łȂȂł傤B

̃Q[iemacs̃EChEł͂Ȃjob`[hœɂ́A
  UNIXShellŉL̃R}hsĂB
     emacs -batch -l dunnet
ӁF̃Q[̓ob`[hœׂłI

p̃IWi̐ǂނɂ R}h helpeng sĂB
ȉ͓{ł̃I}P
  uUNIX̊ȈՐvǂނɂ R}h helpunix sĂB
  uDos PC ̊ȈՐvǂނɂ R}h helpdos sĂB
  uXgvɂ̓R}hhelpverbsĂB
"))
(defun dun-helpunix (args)
  (dun-mprincl
"uUNIX̊ȈՐv
Ep̊JnƏIF  Login  pJn葱B
    [UƃpX[hKvB[Uɂ͈ʂɐl̖OpB
ER}h
   exit spIt
   ls  s݂fBNg̒ɂt@C̖O\t
     t@Cɂ[fBNg][t@C][Qit@C]B
     E[ɏꂽ񂪃t@CB
     [̋L d ȂfBNgB - Ȃ當܂͂Qit@CB
   pwd s݂̃fBNg\t
   cd <fBNg>  sʂ̃fBNgֈړt
     F cd ..    ^ЂƂ̃fBNgֈړB
          cd user  ^userƂÕfBNgֈړB
   cat <t@C> st@C̋L^eót
   uncompress <kt@C> skꂽt@Cɖ߂t
     kt@Cɂ̓t@Č .Z ƂLB
   rlogin <zXgRs[^> slbg[Nĕʂ̃zXgɃOCt
     [UƃpX[hKvB
     unɂRs[^ɃOCĎgpB
     i̊ԁAݎgp̃Rs[^͎gpłȂȂj
   ftp <zXgRs[^>
     [UƃpX[hKvBł̃OCɂ̓[U anonymous 𗘗pB
"))
(defun dun-helpdos (args)
  (dun-mprincl
"uDos-PC̊ȈՐv
Ep̊JnƏIF
    tbs[fBXNZbgēdȂiresetjƋNB
    Np̃VXe͑Sătbs[fBXN̒ɓĂB
    NɎ͂悤邪A͂EnterėǂB

ER}h
   exit spIt
   dir  s݂fBNg̒ɂt@C̖O\t
     COMMAND  COM     47845 05-01-04   2:00
     AUTOEXEC BAT        24 05-27-04   1:01
     SAMPLE   TXT       102 06-12-08   0:00
        3 file(s)     47971 bytes
     L̕\ł́Acommand.com, autoexec.bat, sample.txt Ƃ
     ÔR̃t@C݂邱ƂӖB

   type <t@C> st@C̋L^eót
     F type sample.txt  
          isample.txt ƂÕt@C̒g\j
"))
(defun dun-helpverb (args)
  (dun-mprincl
"̃Xgiꕔj
  answerij,board/onij,breaki󂷁j,chop/cuti؂j,
  climbioj,dropiuj, digi@j,drivei^]j,
  enter/inij,exit/outioj,eatiHׂj,flushirj,
  get/takeij,goisj,look/examine/readij,
  press/pushij,put/inserti put A in Bj,resetidȂj,
  shake/waveiUj,sleep/lieiQj,swinijj,
  throwij,turni܂킷j,typei͂j, urinate/pissiւj,

  score XRAiQ[NAƏ܎^̃bZ[W\j
  inventory/i ij
  save t@C    iw肵Õt@C쐬ăQ[ۑj
  restore t@C iw肵t@CǂݍŃQ[ĊJj
ړ
  east/eij,west/wij,south/sij,north/nikj,southeast/sei쓌j,
  southwest/swi쐼j,northeast/neikj,northwest/nwikj,
  up/uij,down/dij
  
"
))

(defun dun-flush (args)
  (if (not (= dun-current-room bathroom))
      (dun-mprincl "􂢗̂͂܂B")
    (dun-mprincl "Whoooosh!!iW@@@[||||bIIj")
    (dun-put-objs-in-treas (nth urinal dun-room-objects))
    (dun-replace dun-room-objects urinal nil)))

(defun dun-piss (args)
  (if (not (= dun-current-room bathroom))
      (dun-mprincl "ł͂͂ł܂񂵁AȂ͂悤Ƃ炵܂B")
    (if (not dun-gottago)
	(dun-mprincl "Ȃׂł͂Ȃł傤B")
      (dun-mprincl "C悩łB")
      (setq dun-gottago nil)
      (dun-replace dun-room-objects urinal (append 
					    (nth urinal dun-room-objects)
					    (list obj-URINE))))))


(defun dun-sleep (args)
  (if (not (= dun-current-room bedroom))
      (dun-mprincl
"Ȃ͗܂܂ŐQ悤Ƃ܂A͂łȂ悤łB")
    (setq dun-gottago t)
    (dun-mprincl
"Ȃ́AɂƂɖ܂BCƔM̒œẑ悤
A@ēĂJ҂̎p܂BȂ̘͂J҂̂ЂƂ
ł鎖ɋCÂ܂BNĂȂԂɁAȂ̓O[v
ւƕĂ܂B͂̕ĂĂɎ`傫ȐΈȊOɂ
܂BȂ͂ȂgnʂɌ@A̒ɉ
󕨂ǍōĂьɓyĖ߂Ă̂܂B
̒ɁAȂ͖ڂo܂܂B")))

(defun dun-break (obj)
  (let (objnum)
    (if (not (member obj-axe dun-inventory))
	(dun-mprincl "Ȃ͉󂷂߂̓Ă܂B")
      (when (setq objnum (dun-objnum-from-args-std obj))
	(if (member objnum dun-inventory)
	    (progn
	      (dun-mprincl
"Ȃ͂̂̂ɂƂAӂ܂BsKɂȂ
mɓĂ̂ɎsA؂Ă܂܂B
Ȃ͏oʂŎS܂B")
	      (dun-die "an axe"))
	  (if (not (or (member objnum (nth dun-current-room dun-room-objects))
		       (member objnum 
			       (nth dun-current-room dun-room-silents))))
	      (dun-mprincl "͂ɂ͌܂B")
	    (if (= objnum obj-cable)
		(progn
		  (dun-mprincl 
"ȂC[Tlbg̃P[uؒfƁAׂĂڂ
݂͂߂܂BȂ͈uCAĈӎ߂܂B")
		  (dun-replace dun-room-objects gamma-computing-center
			   (append 
			    (nth gamma-computing-center dun-room-objects)
			    dun-inventory))
		  (if (member obj-key dun-inventory)
		      (progn
			(setq dun-inventory (list obj-key))
			(dun-remove-obj-from-room 
			 gamma-computing-center obj-key))
		    (setq dun-inventory nil))
		  (setq dun-current-room computer-room)
		  (setq dun-ethernet nil)
		  (dun-mprincl "Connection closed.iڑIj")
		  (dun-unix-interface))
	      (if (< objnum 0)
		  (progn
		    (dun-mprincl "͂ȂȂɍӂUĂ܂܂B")
		    (dun-remove-obj-from-inven obj-axe))
		(dun-mprincl "͂ȂȂɉ󂵂܂B")
		(dun-remove-obj-from-room dun-current-room objnum)))))))))

(defun dun-drive (args)
  (if (not dun-inbus)
      (dun-mprincl "蕨Ȃ΁AȂ͉^]邱Ƃł܂B")
    (dun-mprincl "oXɏĂԂ́Ap͂邾ŉ^]ł܂B")))

(defun dun-superb (args)
  (setq dun-mode 'dun-superb))

(defun dun-reg-score ()
  (let (total)
    (setq total 0)
    (dolist (x (nth treasure-room dun-room-objects))
      (setq total (+ total (nth x dun-object-pts))))
    (if (member obj-URINE (nth treasure-room dun-room-objects))
	(setq total 0)) total))

(defun dun-endgame-score ()
  (let (total)
    (setq total 0)
    (dolist (x (nth endgame-treasure-room dun-room-objects))
      (setq total (+ total (nth x dun-object-pts)))) total))

(defun dun-answer (args)
  (if (not dun-correct-answer)
      (dun-mprincl "NȂɓ߂ĂȂ͂łB")
    (setq args (car args))
    (if (not args)
	(dun-mprincl " answer ̌ɓLqĂB")
      (if (dun-members args dun-correct-answer)
	  (progn
	    (dun-mprincl "B")
	    (if (= dun-lastdir 0)
		(setq dun-current-room (1+ dun-current-room))
	      (setq dun-current-room (- dun-current-room 1)))
	    (setq dun-correct-answer nil))
	(dun-mprincl "̉񓚂͊ԈĂ܂B")))))

(defun dun-endgame-question ()
(if (not dun-endgame-questions)
    (progn
      (dun-mprincl "Ȃւ͎̎̒ʂłF")
      (dun-mprincl " ͂܂B'answer foo' Ɠ͂ĂB.")
      (setq dun-correct-answer '("foo"))
      (setq dun-question-message "-1"))
  (let (which i newques)
    (setq i 0)
    (setq newques nil)
    (setq which (random (length dun-endgame-questions)))
    (dun-mprincl "Ȃւ͎̎̒ʂłF")
    (setq dun-question-message
        (setq dun-endgame-question (car (nth which 
					  dun-endgame-questions))))
    (dun-mprincl (cdr (assoc dun-question-message dun-endgame-questions-msg)))
    (setq dun-correct-answer (cdr (nth which dun-endgame-questions)))
    (while (< i which)
      (setq newques (append newques (list (nth i dun-endgame-questions))))
      (setq i (1+ i)))
    (setq i (1+ which))
    (while (< i (length dun-endgame-questions))
      (setq newques (append newques (list (nth i dun-endgame-questions))))
      (setq i (1+ i)))
    (setq dun-endgame-questions newques))))

(defun dun-power (args)
  (if (not (= dun-current-room pc-area))
      (dun-mprincl "̑͂ł͏o܂B")
    (if (not dun-floppy)
	(dun-dos-no-disk)
      (dun-dos-interface))))

(defun dun-feed (args)
  (let (objnum)
    (when (setq objnum (dun-objnum-from-args-std args))
      (if (and (= objnum obj-bear) 
	       (member obj-bear (nth dun-current-room dun-room-objects)))
	  (progn
	    (if (not (member obj-food dun-inventory))
		(dun-mprincl "Ȃ͂ɐĤׂĂ܂B")
	      (dun-drop '("food"))))
	(if (not (or (member objnum (nth dun-current-room dun-room-objects))
		     (member objnum dun-inventory)
		     (member objnum (nth dun-current-room dun-room-silents))))
	    (dun-mprincl "͂ɂ͌܂B")
	  (dun-mprincl "Ȃ͂ɐHׂ(feed)Ƃ͂ł܂B
iɂ͐Hׂ鑊w肵Ăj"))))))


;;;;
;;;;  This section defines various utility functions used
;;;;  by dunnet.
;;;;


;;; Function which takes a verb and a list of other words.  Calls proper
;;; function associated with the verb, and passes along the other words.

(defun dun-doverb (dun-ignore dun-verblist verb rest)
  (if (not verb)
      nil
    (if (member (intern verb) dun-ignore)
	(if (not (car rest)) -1
	  (dun-doverb dun-ignore dun-verblist (car rest) (cdr rest)))
      (if (not (cdr (assq (intern verb) dun-verblist))) -1
	(setq dun-numcmds (1+ dun-numcmds))
	(eval (list (cdr (assq (intern verb) dun-verblist)) (quote rest)))))))


;;; Function to take a string and change it into a list of lowercase words.

(defun dun-listify-string (strin)
  (let (pos ret-list end-pos)
    (setq pos 0)
    (setq ret-list nil)
    (while (setq end-pos (string-match "[ ,:;]" (substring strin pos)))
      (setq end-pos (+ end-pos pos))
      (if (not (= end-pos pos))
	  (setq ret-list (append ret-list (list 
					   (downcase
					    (substring strin pos end-pos))))))
      (setq pos (+ end-pos 1))) ret-list))

(defun dun-listify-string2 (strin)
  (let (pos ret-list end-pos)
    (setq pos 0)
    (setq ret-list nil)
    (while (setq end-pos (string-match " " (substring strin pos)))
      (setq end-pos (+ end-pos pos))
      (if (not (= end-pos pos))
	  (setq ret-list (append ret-list (list 
					   (downcase
					    (substring strin pos end-pos))))))
      (setq pos (+ end-pos 1))) ret-list))

(defun dun-replace (list n number)
  (rplaca (nthcdr n list) number))


;;; Get the first non-ignored word from a list.

(defun dun-firstword (list)
  (if (not (car list))
      nil
    (while (and list (member (intern (car list)) dun-ignore))
      (setq list (cdr list)))
    (car list)))

(defun dun-firstwordl (list)
  (if (not (car list))
      nil
    (while (and list (member (intern (car list)) dun-ignore))
      (setq list (cdr list)))
    list))

;;; parse a line passed in as a string  Call the proper verb with the
;;; rest of the line passed in as a list.

(defun dun-vparse (dun-ignore dun-verblist line)
  (dun-mprinc "\n")
  (setq line-list (dun-listify-string (concat line " ")))
  (dun-doverb dun-ignore dun-verblist (car line-list) (cdr line-list)))

(defun dun-parse2 (dun-ignore dun-verblist line)
  (dun-mprinc "\n")
  (setq line-list (dun-listify-string2 (concat line " ")))
  (dun-doverb dun-ignore dun-verblist (car line-list) (cdr line-list)))

;;; Read a line, in window mode

(defun dun-read-line ()
  (let (line)
    (setq line (read-string ""))
    (dun-mprinc line) line))

;;; Insert something into the window buffer

(defun dun-minsert (string)
  (if (stringp string)
      (insert string)
    (insert (prin1-to-string string))))

;;; Print something out, in window mode

(defun dun-mprinc (string)
  (if (stringp string)
      (insert string)
    (insert (prin1-to-string string))))

;;; In window mode, keep screen from jumping by keeping last line at
;;; the bottom of the screen.

(defun dun-fix-screen ()
  (interactive)
  (forward-line (- 0 (- (window-height) 2 )))
  (set-window-start (selected-window) (point))
  (end-of-buffer))

;;; Insert something into the buffer, followed by newline.

(defun dun-minsertl (string)
  (dun-minsert string)
  (dun-minsert "\n"))

;;; Print something, followed by a newline.

(defun dun-mprincl (string)
  (dun-mprinc string)
  (dun-mprinc "\n"))

;;; Function which will get an object number given the list of
;;; words in the command, except for the verb.

(defun dun-objnum-from-args (obj)
  (let (objnum)
    (setq obj (dun-firstword obj))
    (if (not obj)
	obj-special
      (setq objnum (cdr (assq (intern obj) dun-objnames))))))

(defun dun-objnum-from-args-std (obj)
  (let (result)
  (if (eq (setq result (dun-objnum-from-args obj)) obj-special)
      (dun-mprincl "ړI^Kv܂B"))
  (if (eq result nil)
      (dun-mprincl "ꂪ킩܂B"))
  (if (eq result obj-special)
      nil
    result)))

;;; Take a short room description, and change spaces and slashes to dashes.

(defun dun-space-to-hyphen (string)
  (let (space)
    (if (setq space (string-match "[ /]" string))
	(progn
	  (setq string (concat (substring string 0 space) "-"
			       (substring string (1+ space))))
	  (dun-space-to-hyphen string))
      string)))

;;; Given a unix style pathname, build a list of path components (recursive)

(defun dun-get-path (dirstring startlist)
  (let (slash pos)
    (if (= (length dirstring) 0)
	startlist
      (if (string= (substring dirstring 0 1) "/")
	  (dun-get-path (substring dirstring 1) (append startlist (list "/")))
	(if (not (setq slash (string-match "/" dirstring)))
	    (append startlist (list dirstring))
	  (dun-get-path (substring dirstring (1+ slash))
		    (append startlist
			    (list (substring dirstring 0 slash)))))))))


;;; Is a string a member of a string list?

(defun dun-members (string string-list)
  (let (found)
    (setq found nil)
    (dolist (x string-list)
      (if (string= x string)
	  (setq found t))) found))

;;; Function to put objects in the treasure room.  Also prints current
;;; score to let user know he has scored.

(defun dun-put-objs-in-treas (objlist)
  (let (oscore newscore)
    (setq oscore (dun-reg-score))
    (dun-replace dun-room-objects 0 (append (nth 0 dun-room-objects) objlist))
    (setq newscore (dun-reg-score))
    (if (not (= oscore newscore))
	(dun-score nil))))

;;; Load an encrypted file, and eval it.

(defun dun-load-d (filename)
  (let (old-buffer result)
    (setq result t)
    (setq old-buffer (current-buffer))
    (switch-to-buffer (get-buffer-create "*loadc*"))
    (erase-buffer)
    (condition-case nil
	(insert-file-contents filename)
      (error (setq result nil)))
    (unless (not result)
      (condition-case nil
	  (dun-rot13)
	(error (yank)))
      (eval-current-buffer)
      (kill-buffer (current-buffer)))
      (switch-to-buffer old-buffer)
    result))

;;; Functions to remove an object either from a room, or from inventory.

(defun dun-remove-obj-from-room (room objnum)
  (let (newroom)
    (setq newroom nil)
    (dolist (x (nth room dun-room-objects))
      (if (not (= x objnum))
	  (setq newroom (append newroom (list x)))))
    (rplaca (nthcdr room dun-room-objects) newroom)))

(defun dun-remove-obj-from-inven (objnum)
  (let (new-inven)
    (setq new-inven nil)
    (dolist (x dun-inventory)
      (if (not (= x objnum))
	  (setq new-inven (append new-inven (list x)))))
    (setq dun-inventory new-inven)))


(let ((i 0) (lower "abcdefghijklmnopqrstuvwxyz") upper)
  (setq dun-translate-table (make-vector 256 0))
  (while (< i 256)
    (aset dun-translate-table i i)
    (setq i (1+ i)))
  (setq lower (concat lower lower))
  (setq upper (upcase lower))
  (setq i 0)
  (while (< i 26)
    (aset dun-translate-table (+ ?a i) (aref lower (+ i 13)))
    (aset dun-translate-table (+ ?A i) (aref upper (+ i 13)))
      (setq i (1+ i))))
  
(defun dun-rot13 ()
  (let (str len (i 0))
    (setq str (buffer-substring (point-min) (point-max)))
    (setq len (length str))
    (while (< i len)
      (aset str i (aref dun-translate-table (aref str i)))
      (setq i (1+ i)))
    (erase-buffer)
    (insert str)))

;;;;
;;;; This section defines the globals that are used in dunnet.
;;;;
;;;; IMPORTANT
;;;; All globals which can change must be saved from 'save-game.  Add
;;;; all new globals to bottom of file.

(setq dun-visited '(27))
(setq dun-current-room 1)
(setq dun-exitf nil)
(setq dun-badcd nil)
(defvar dungeon-mode-map nil)
(setq dungeon-mode-map (make-sparse-keymap))
(define-key dungeon-mode-map "\r" 'dun-parse)
(setq dun-question-message nil)
;;---------------XEmacs ƂȊOŏύX
(if (boundp 'xemacsp)
; XEmacs̏ꍇ
 (defvar dungeon-batch-map
  (let ((map (make-keymap))
        (n 32))
    (while (< 0 (setq n (- n 1)))
      (define-key map (make-string 1 n) 'dungeon-nil))
    (define-key map "\r" 'exit-minibuffer)
    (define-key map "\n" 'exit-minibuffer)
    map)) 
 (progn
; ȊO
 (defvar dungeon-batch-map (make-keymap))
 (if (string= (substring emacs-version 0 2) "18")
    (let (n)
      (setq n 32)
      (while (< 0 (setq n (- n 1)))
	(aset dungeon-batch-map n 'dungeon-nil)))
  (let (n)
    (setq n 32)
    (while (< 0 (setq n (- n 1)))
      (aset (car (cdr dungeon-batch-map)) n 'dungeon-nil))))
 (define-key dungeon-batch-map "\r" 'exit-minibuffer)
 (define-key dungeon-batch-map "\n" 'exit-minibuffer)
 ))
;;-------------------------------
(setq dun-computer nil)
(setq dun-floppy nil)
(setq dun-key-level 0)
(setq dun-hole nil)
(setq dun-correct-answer nil)
(setq dun-lastdir 0)
(setq dun-numsaves 0)
(setq dun-jar nil)
(setq dun-dead nil)
(setq room 0)
(setq dun-numcmds 0)
(setq dun-wizard nil)
(setq dun-endgame-question nil)
(setq dun-logged-in nil)
(setq dungeon-mode 'dungeon)
(setq dun-unix-verbs '((ls . dun-ls) (ftp . dun-ftp) (echo . dun-echo) 
		       (exit . dun-uexit) (cd . dun-cd) (pwd . dun-pwd)
		       (rlogin . dun-rlogin) (uncompress . dun-uncompress)
		       (cat . dun-cat) (zippy . dun-zippy)))

(setq dun-dos-verbs '((dir . dun-dos-dir) (type . dun-dos-type)
		      (exit . dun-dos-exit) (command . dun-dos-spawn)
		      (b: . dun-dos-invd) (c: . dun-dos-invd)
		      (a: . dun-dos-nil)))


(setq dun-batch-mode nil)

(setq dun-cdpath "/usr/toukmond")
(setq dun-cdroom -10)
(setq dun-uncompressed nil)
(setq dun-ethernet t)
(setq dun-restricted 
      '(dun-room-objects dungeon-map dun-rooms 
			 dun-room-silents dun-combination))
(setq dun-ftptype 'ascii)
(setq dun-endgame nil)
(setq dun-gottago t)
(setq dun-black nil)

(setq dun-rooms '(
	      (
"Ȃ͕󕨌ɂɂ܂Bk(north)ɂ̓hA܂B"
               "Treasure room" "󕨌"
	       )
	      (
"Ȃܑ͕ĂȂ̍s~܂ɂ܂D͓(east,E)ւƑ
܂D̓̕łQɕĂ̂܂D
ɂ͂ƂĂw̍V̖(palm)ĂC݂͌ɓԊu
Ȃł܂D"
	       "Dead end" "s~܂"
	       )
	      (
"Ȃܑ͕ĂȂ̓rɂ܂DȂ̍Eɂ͑؁X
Ă܂D͓(east,E)Ɛ(west,E)ɑĂ܂D"
               "E/W Dirt road" "ɑ"
	       )
	      (
"Ȃ͂Qɕꂽ̕_ɂ܂D͖̓k(northeast,NE)C
͓̓쓌(southeast,SEjւƑĂ܂D̒nʂ͂ƂĂ
炩悤łDȂ͐(west,W)ւƖ߂邱Ƃł܂D"
               "Fork" "̕_"
	       )
	      (
"Ȃ́Ck(NE)Ɠ쐼(SWjւƑ̓rɂ܂D"
               "NE/SW road" "k-쐼Ȃ"
	       )
	      (
"Ȃ͓̂͂ɂ܂DȂ̖ڂ̑OCk(NE)̕pɌ
܂D͓̓쐼(SW)ւƑĂ܂D"
               "Building front" "̑O"
	       )
	      (
"Ȃ́C쓌(SE)Ɩk(NWjւƑ̓rɂ܂D"
               "SE/NW road" "쓌-kȂ"
	       )
	      (
"Ȃ͓̍s~܂ɗĂ܂D߂铹͖k(NW)ɂ܂D"
               "Bear hangout" "F̏Z݂"
	       )
	      (
"Ȃ͌Â̘Lɂ܂D(E)Ɛ(W)ɕC
k(N)Ɠ(S)ɊO֒ʂhA܂D"
               "Old Building hallway" "Â̘L"
	       )
	      (
"Ȃ͗X֕̒̕ɂ܂BX֕(mail)Ă߂̐
唠(bin)܂B̏o͐(W)łB"
               "Mailroom" "X֕̕"
	       )
	      (
"Ȃ͌vZ@̒ɂ܂Bȗ啔͎菜Ă悤łB
Ȃ̖ڂ̑Oɂ́AVAX 11/780 ̃Rs[^(computer)܂B
ARs[^̃LrlbĝЂƂLJĂ܂B
@B̑Oʂ̏ɂ͎̂悤ɏĂ܂B
              u VAX ̖O 'pokey'Bv
R\[pē͂ɂ́A 'type' gĂB
o͓(E)ɂ܂B"
               "Computer room" "vZ@"
	       )
	      (
"Ȃ͌Â̌ɂqnɂ܂Bȏ(W)ւƑ
܂B(S)ɂ̓hA܂B"
               "Meadow" "qn"
	       )
	      (
"Ȃ͓(E)ɃhAA΂łłۂ̒ɂ܂B
ǂɂ́ureceiving roomvƓǂ߂镶ĂB"
               "Receiving room" "M["
	       )
	      (
"Ȃ͖k(N)ւƑL̓(S)̒[ɂ܂B
(E)Ɛ(W)ɕ܂B"
               "Northbound Hallway" "k֑L"
	       )
	      (
"Ȃ̓TEiɂ܂Bǂɂ_CA(dial)ȊOɂ͕ɉ
܂BhA͐(W)̊OւƓ܂B"
               "Sauna" "TEi"
               )
	      (
"Ȃ͓(S)Ɩk(N)ɑL̖k̒[ɂ܂BȂ͓(S)ɖ߂邱ƂA
(E)ɂ镔ւƏo邱Ƃł܂B"
               "End of N/S Hallway" "k-ȂL̒["
	       )
	      (
"Ȃ͌ÂEGCg[ɂ܂BSẴg[jO@͌̏Ⴕ
邩A邢͊SɉĂ܂B(W)ɊO֏ohAA
ɊJ(hole)֍~(down,D)߂̃nVS(ladder)܂B"
               "Weight room" "EGCg["                ;16
	       )
	      (
"Ȃ́ASĂʂAȂ肭˂ׂ̖Hɂ܂B
̒nʂ̏ɂ̓{^(button)܂B"
               "Maze button room" "HF{^["
	       )
	      (
"Ȃ́ASĂʂAȂ肭˂ׂ̖Hɂ܂B"
               "Maze" "H"
	       )
	      (
"Ȃ́ASĂʂAȂ肭˂̖Hɂ܂B"
               "Maze" "H"    ;19
	       )
	      (
"Ȃ́ASĂގAȂ肭˂ׂ̖Hɂ܂B"
               "Maze" "H"
	       )
	      (
"Ȃ́ASĂʂAׂċȂ肭˂Hɂ܂B"
               "Maze" "H"   ;21
	       )
	      (
"Ȃ́ASĂʂAȂ肭˂ׂH̖Hɂ܂B"
               "Maze" "H"   ;22
	       )
	      (
"Ȃ͌NtBbglXZ^[̎t[ɂ܂B
̏ꏊ͍ŋߗDꂽ悤ŁAcĂ܂B
(S)ɊO֏ohAA쓌(SE)ɖHւ̓܂B"
               "Reception area" "t["
	       )
	      (
"Ȃ͖k(N)ɂ錒NtBbglXZ^[ł낤傫Ȍ
Oɂ܂B͓(S)֑Ă܂B"
               "Health Club front" "wXNȗO"
	       )
	      (
"Ȃ͌(lake)̖k(N)ɂ܂B΂݂̌ɂ́AAւƑ
̂܂B͂ƂĂ[悤łB"
               "Lakefront North" "΂̖k̊"
	       )
	      (
"Ȃ͌(lake)̓쑤(S)ɂ܂B͓(S)ɑĂ܂B"
               "Lakefront South" "΂̓쑤̊"
	       )
	      (
"Ȃ͓班ꂽABꂽGAɂ܂B
k(NE)ɂGؗт̌ɁAF̏Z݂܂B"
               "Hidden area" "BꂽGA"
	       )
	      (
"A͓̓(S)ɂ܂Bk(N)́A[΂֌łB
΂̒nʂɂ̓V[g(chute)AɊŔ܂B
ɂ́u_𓾂ɂ͕󕨂֓(put)BvƏĂ܂B"
               "Cave Entrance" "A̓"                     ;28
	       )
	      (
"Ȃ͎R̒ɂꂽA̗߂邵߂ۂɂ܂B
k(N)ɂ͊̌オ܂B(E)ɈÈłւƑʘH܂B"              ;29
               "Misty Room" "߂"
	       )
	      (
"Ȃ͓(E),(W)ɑʘHɂ܂B̕ǂ͗lXȐF̊
łĂāAƂĂYłB"
               "Cave E/W passage" "-֑A̒ʘH"                  ;30
	       )
	      (
"Ȃ͓A̕ꓹɂ܂Bk(N)A(S)̑ɁA(W)ւ
s܂B"
               "N/S/W Junction" "kEE̕ꓹ"                    ;31
	       )
	      (
"Ȃ͓-k(S/N)ɂ̂тʘH̖k̒[ɂ܂B牺(D)ւ
~邽߂̊Ki܂B(W)ɍs߂̃hA܂B"
               "North end of cave passage" "A̒ʘH̖k["        ;32
	       )
	      (
"Ȃ͓-k(S/N)ɂ̂тʘH̓̒[ɂ܂B̏ɂ͌(hole)
Ă܂B傤ǂȂ̂ɂ傫̌łB"
               "South end of cave passage" "A̒ʘH̓["        ;33
	       )
	      (
"ȂJ҂̃xbh[̂悤ȏꏊɂ܂B̒ɂ
NC[TCỸxbh(bed)Aǂɂ͊G(painting)Ă܂B
(S)ɂ͕ʂ̕ւ̃hAA(U)Ɖ(D)֍s߂̊Ki
܂B"
               "Bedroom" "xbh["                         ;34
	       )
	      (
"Ȃ͓A̒ɂJ҂̂߂̃oX[ɂ܂B
֊(urinal)ǂɂĂ܂BāAΑ̕ǂł
VNŎg߂̃pCv(pipe)oɂȂĂ܂B
k(N)ɂ̓xbh[܂B"
               "Bathroom" "oX["       ;35
	       )
	      (
"͏֊̂߂̃}[J[łB Q[̃vC[͌邱Ƃł
񂪁Aɂ̓m܂܂B"
               "Urinal" "֊"         ;36
	       )
	      (
"Ȃ͖k-쐼(NE/SW)̒ʘH̖k(NE)̒[ɂ܂B
Ki͂悭Ȃ(U)̊KւƂÂĂ܂B"
               "NE end of NE/SW cave passage" "k-쐼̍B̖k̒["      ;37
	       )
	      (
"Ȃ͖k-쐼(NE/SW)̒ʘHƓ(E/W)̒ʘHꏊɂ܂B"
               "NE/SW-E/W junction" "B̌_"                     ;38
	       )
	      (
"Ȃ͖k-쐼(NE/SW)̒ʘH̓쐼(SW)̒[ɂ܂B"
               "SW end of NE/SW cave passage" "k-쐼̍B̓쐼̒["       ;39
	       )
	      (
"Ȃ͓-(E/W)̒ʘH̓(E)̒[ɂ܂BKi͏(U)ɂ镔ւ
ÂĂ܂B"
               "East end of E/W cave passage" "-̍B̓̒["       ;40
	       )
	      (
"Ȃ͓-(E/W)̒ʘH̐(W)̒[ɂ܂B̒nʂɂ͌
A(D)ɂ錩ȂꏊւƂÂĂ܂B"
               "West end of E/W cave passage" "-̍B̐̒["      ;41
	       )
	      (
"Ȃ́AɂĂĂ̌`傫Ȑ΁iboulderj邾
Ƃɂ܂B牺(D)֍sKi܂B"     ;42
               "Horseshoe boulder room" "ĂĂ̐΂̂镔"
	       )
	      (
"Ȃ͂܂Ȃ̒ɂ܂Bk(N)ւ̃hA܂B"
               "Empty room" "Ȃ"                     ;43
	       )
	      (
"Ȃ͉Ȃɂ܂B̐̕(stone)͐FœhĂ܂B
hẢ͓(E)Ɠ(S)ւƂÂ܂B"  ;44
               "Blue room" ""
	       )
	      (
"
Ȃ͉Ȃɂ܂B̐̕(stone)͉FœhĂ܂B
hẢ͓(S)Ɛ(W)ւƂÂ܂B"    ;45
               "Yellow room" "F"
	       )
	      (
"Ȃ͉Ȃɂ܂B̐̕(stone)͐ԐFœhĂ܂B
hẢ͐(W)Ɩk(N)ւƂÂ܂B"
               "Red room" "Ԃ"                                ;46
	       )
	      (
"Ȃ́Ak-(N/S)ȂL̒Ԓn_ɂ܂B"     ;47
               "Long n/s hallway" "k-̒L̒"
	       )
	      (
"Ȃ́Ak-(N/S)ȂĹAk[֌3/4قǐi
ʒuɂ܂B"
               "3/4 north" "3/4k֐i񂾒n_"                               ;48
	       )
	      (
"Ȃ́Ak-(N/S)ȂL̖k̒[ɂ܂B
Ki(U)ւÂĂ܂B"
               "North end of long hallway" "L̖k̒["                ;49
	       )
	      (
"Ȃ́Ak-(N/S)ȂĹA[֌3/4قǐi
ʒuɂ܂B"
               "3/4 south" "3/4ւn_"                                ;50
	       )
	      (
"Ȃ́Ak-(N/S)ȂL̓̒[ɂ܂B
(S)Ɍ܂B"
               "South end of long hallway" "L̓̒["                ;51
	       )
	      (
"Ȃ͏-(U/D)ɂÂ̊Ki̗xɂ܂B"
               "Stair landing" "Ki̗x"                            ;52
	       )
	      (
"Ȃ͏㉺(U/D)ɂÂKi̓rɂ܂B"
               "Up/down staircase" "㉺ւÂKi"                        ;53
	       )
	      (
"Ȃ͉(D)ւƂÂKïԏɂ܂B
ƘH(crawlway)k(NE)ւÂĂ܂B"
               "Top of staircase." "Ki̒"                       ;54
	       )
	      (
"Ȃ́AƘHɂ܂Bk(NE)܂͓쐼(SW)ɍs܂B"
               "NE crawlway" "ƘH̖k"                             ;55
	       )
	      (
"Ȃ͏ȍƃXy[X̒ɂ܂B̒nʂɂ͑傫Ȍ
Ă܂BāAȒʘH쐼(SW)ɑĂ܂B"
               "Small crawlspace" "ƃXy[X"                        ;56
	       )
	      (
"Ȃ Gamma Rs[^Z^[ɂ܂B
ł IBM 3090/600s Ƃ@̃Rs[^(computer)t@̉
uu炵ȂғĂ܂BjbĝЂƂC[Tlbg
P[u(cable)oĂAꂪVւƂ̂тĂ܂B
ȂR}h^Cvł悤ȑ@͂ɂ͂܂B"
               "Gamma computing center" "Gamma Rs[^Z^["                  ;57
	       )
	      (
"Ȃ͗X֋ǂ̐Ղɂ܂B̐ʂɗX֎(mail)܂A
Ȃ͂ꂪǂ֓͂邱Ƃ͂ł܂B
(E)ւƖ߂ʘHƁAk(N)ւÂ܂B"
               "Post office" "X֋"                            ;58
	       )
	      (
"Ȃ̓Cʂ(Main Street)ƃJGfʂ(Maple Ave)̌_ɂ܂B
Cʂ͖k(N)(S)ւƂ͂ĂAJGfʂ͓(E)̉
Ă͂Ă܂BȂkɖڂƂ̌_
܂BAߋɂł낤ׂĂ̌͂ȂȂĂ܂B
HW(sign)ȊOAcĂ܂B
k(NW)ɂ́A邩̂悤Ȗ(gate)܂B"
               "Main-Maple intersection" "C-JGf_"                      ;59
	       )
	      (
"Ȃ́ACʂ(Main Street)ƃI[N̖ؒʂ(Oaktree Ave)̐̒[Ƃ
_ɂ܂B"
               "Main-Oaktree intersection" "C-I[N̖،_"  ;60
	       )
	      (
"Ȃ́ACʂ(Main Street)ƃo[gʂ(Vermont Ave)̐̒[Ƃ
_ɂ܂B"
               "Main-Vermont intersection" "C-o[g_" ;61
	       )
	      (
"Ȃ́ACʂ(Main Street)̖k̒[ƃC`WNʂ(Sycamore Ave)
̒[ƂȂn_ɂ܂B" ;62
               "Main-Sycamore intersection" "C-C`WN_"
	       )
	      (
"Ȃ͑Pʂ(First Street)̓̒[ƃJGfʂ(Maple Ave)̌_
ɂ܂B" ;63
               "First-Maple intersection" "P-JGf_"
	       )
	      (
"Ȃ͑Pʂ(First Street)ƃI[N̖ؒʂ(Oaktree Ave)̌_ɂ܂B"  ;64
               "First-Oaktree intersection" "P-I[N̖،_"
	       )
	      (
"Ȃ͑Pʂ(First Street)ƃo[gʂ(Vermont Ave)̌_
ɂ܂B"  ;65
               "First-Vermont intersection" "P-o[g_"
	       )
	      (
"Ȃ͑Pʂ(First Street)̖k̒[ƃC`WNʂ(Sycamore Ave)
_ɂ܂B"  ;66
               "First-Sycamore intersection" "P-C`WN_"
	       )
	      (
"Ȃ͑Qʂ(Second Street)̓̒[ƃJGfʂ(Maple Ave)̌_
܂B" ;67
               "Second-Maple intersection" "Q-JGf_"
	       )
	      (
"Ȃ͑Qʂ(Second Street)ƃI[N̖ؒʂ(Oaktree Ave)̌_ɂ܂B"  ;68
               "Second-Oaktree intersection" "Q-I[N̖،_"
	       )
	      (
"Ȃ͑Qʂ(Second Street)ƃo[gʂ(Vermont Ave)̌_
ɂ܂B"  ;69
               "Second-Vermont intersection" "Q-o[g_"
	       )
	      (
"Ȃ͑Qʂ(Second Street)Ɩk̒[ƃC`WNʂ(Sycamore Ave)
_ɂ܂B"  ;70
               "Second-Sycamore intersection" "Q-C`WN_"
	       )
	      (
"Ȃ́ARʂ(Third Street)̓̒[ƃJGfʂ(Maple Ave)̌_
ɂ܂B"  ;71
               "Third-Maple intersection" "R-JGf_"
	       )
	      (
"Ȃ͑Rʂ(Third Street)ƃI[N̖ؒʂ(Oaktree Ave)̌_ɂ܂B"  ;72
               "Third-Oaktree intersection" "R-I[N̖،_"
	       )
	      (
"Ȃ͑Rʂ(Third Street)ƃo[gʂ(Vermont Ave)̌_
ɂ܂B"  ;73
               "Third-Vermont intersection" "R-o[g_"
	       )
	      (
"Ȃ͑Rʂ(Third Street)Ɩk̒[ƃC`WNʂ(Sycamore Ave)
_ɂ܂B"  ;74
               "Third-Sycamore intersection" "R-C`WN_"
	       )
	      (
"Ȃ͑Sʂ(Fourth Street)Ɠ̒[ƃJGfʂ(Maple Ave)̌_
ɂ܂B"  ;75
               "Fourth-Maple intersection" "S-JGf_"
	       )
	      (
"Ȃ͑Sʂ(Fourth Street)ƃI[N̖ؒʂ(Oaktree Ave)̌_ɂ܂B"  ;76
               "Fourth-Oaktree intersection" "S-I[N̖،_"
	       )
	      (
"Ȃ͑Sʂ(Fourth Street)ƃo[gʂ(Vermont Ave)̌_
ɂ܂B"  ;77
               "Fourth-Vermont intersection" "S-o[g_"
	       )
	      (
"Ȃ͑Sʂ(Fourth Street)Ɩk̒[ƃC`WNʂ(Sycamore Ave)
_ɂ܂B"  ;78
               "Fourth-Sycamore intersection" "S-C`WN_"
	       )
	      (
"Ȃ͑Tʂ(Fifth Street)̓̒[ƃJGfʂ(Maple Ave)
̒[ƂȂn_ɂ܂B"  ;79
               "Fifth-Maple intersection" "T-JGf_"
	       )
	      (
"Ȃ͑Tʂ(Fifth Street)ƃI[N̖ؒʂ(Orktree Ave)̓̒[Ƃ
_ɂ܂B(E)͐؂藧R(cliff)łB"
               "Fifth-Oaktree intersection" "T-I[N̖،_" ;80
	       )
	      (
"Ȃ͑Tʂ(Fifth Street)ƃo[gʂ(Vermont Ave)̓̒[Ƃ
_ɂ܂B"
               "Fifth-Vermont intersection" "T-o[g_" ;81
	       )
	      (
"Ȃ͑Tʂ(Fifth Street)̓̒[ƃC`WNʂ(Sycamore Ave)
̒[ƂȂn_ɂ܂B"
               "Fifth-Sycamore intersection" "T-C`WN_" ;82
	       )
	      (
"Ȃ͎Rj(Museum of Natural History)̑Oɂ܂B
k(N)̃hA͌̒ւƂȂ𓱂܂B͓쓌(SE)ւÂĂ܂B"
               "Museum entrance" "ق̓"                 ;83
	       )
	      (
"Ȃ͎Rjق̃CEr[ɂ܂B
̒ɋȋ(dinosaur)̃KCRc܂B
(S)Ɠ(E)ɃhA܂B "
               "Museum lobby" "ق̃r["                    ;84
	       )
	      (
"Ȃ͒nw̓Wɂ܂BWĂ͂̂̂͑SĎ
܂Ă܂B(E)Ɛ(W)Ɩk(N)ɕ܂B"
               "Geological display" "nw̓W"              ;85
	       )
	      (
"Ȃ͊Cm̃GAɂ܂B͐(tank)ŖĂ܂B
͌Ƃł͉aȂȂ߂Ɏ񂾂Ǝv鋛(fish)̎[
Ă܂B(S)Ɠ(E)ɃhA܂B"
               "Marine life area" "Cm̃GA"                  ;86
	       )
	      (
"Ȃ͔ق̊Ǘ̂ЂƂɂ܂Bǂ̏ u BL vƏꂽ
x̂XCb`(switch)܂B(W)Ɩk(N)ւ̃hA܂B"
               "Maintenance room" "Ǘ"                  ;87
	       )
	      (
"Ȃ́AwɂĎqǂɋ̂ɎgĂɂ܂B
(blackboard)ɂ́u qǂ͉̊K֍ŝ͋Ă܂v
Ă܂Bɂ͓(E)ւ̃hAȀɂ͏o(exit)
\Ă܂BЂƂ̃hA(W)ɂ܂B"
               "Classroom" ""                         ;88
	       )
	      (
"Ȃ̓o[gʂ̒nS̉wɂ܂Bd(train)o҂
ԂĂ܂B"
               "Vermont station" "o[gw"                   ;89
	       )
	      (
"Ȃ͔ق̒nS̉wɂ܂BʘHk(N)ւƂÂĂ܂B"
               "Museum station" "ىw"                    ;90
	       )
	      (
"Ȃ͖k(N)-(S)ނԃgl̒ɂ܂B"
               "N/S tunnel" "k-̃gl"                         ;91
	       )
	      (
"Ȃ͖k(N)-(S)ނԃgl̖k̒[ɂ܂B
㉺(U/D)ֈړ邽߂̊Ki܂B
ɂ̓S~@(garbage disposal)܂B"
               "North end of N/S tunnel" "k-̃gl̖k̒["            ;92
               )
	      (
"Ȃ͒nS̉ŵ΂̊Ki̍ŏwɂ܂B(W)ɃhA܂B"
               "Top of subway stairs" "nS̊Kȉ"          ;93
	       )
	      (
"Ȃ͒nS̉ŵ΂̊Ki̍ŉwɂ܂Bk(NE)
܂B"
               "Bottom of subway stairs" "nS̉w̒"      ;94
	       )
	      (
"Ȃ͂ЂƂ̌vZ@ɂ܂Bɂ͂Ȃ܂łɌ
Ȃ悤ȋȃRs[^(computer)܂B
ɂ̖͐OȂǂ͏Ă܂񂪁ǍfȂĂ܂B
              ũ}V̖O 'endgame'v
o͓쐼(SW)ɂ܂BȂR}h^Cvł悤ȑ@
ɂ͂܂B"
               "Endgame computer room" "EndgamevZ@"        ;95
	       )
	      (
"Ȃ́A(S)-k(N)ȂʘHɂ܂B"
               "Endgame N/S hallway" "Endgame̓-k̒ʘH"          ;96
	       )
	      (
"Ȃ͑P⃋[ɂ܂BȂ؂蔲邽߂ɂ́A
mɎɓȂ΂Ȃ܂Bɓɂ(answer)g
i Fanswer foo)"
               "Question room 1" "P⃋["             ;97
	       )
	      (
"Ȃ́A(S)-k(N)ȂʘHɂ܂B"
               "Endgame N/S hallway" "Endgame̓-k̒ʘH"          ;98
	       )
	      (
"Ȃ͑Q⃋[ɂ܂B"
               "Question room 2"  "Q⃋["             ;99
	       )
	      (
"Ȃ́A(S)-k(N)ȂʘHɂ܂B"
               "Endgame N/S hallway" "Endgame̓-k̒ʘH"          ;100
	       )
	      (
"Ȃ͑R⃋[ɂ܂B"
               "Question room 3"  "R⃋["              ;101
	       )
	      (
"Ȃ endgame ̕󕨌ɂɂ܂Bk(N)ւ̃hAAʘH͓(S)
ÂĂ܂B"
               "Endgame treasure room" "Endgame̕󕨌"        ;102
	       )
	      (
"Ȃ͏҂̕ɂ܂B(S)ɃhA܂B"
               "Winner's room" "҂̕"                ;103
	       )
	      (
"Ȃ͍s~܂ɂ܂B̏ɂ̓p\R(PC)܂B
̃p\Rɂ͕\ȂĂ܂B͎̂悤ɓǂ߂܂B
  ũp\RZbgid̓꒼, reset jBv
͖k(N)ւÂĂ܂B"
               "PC area"   "p\RGA"                    ;104
               )            
))

(setq dun-light-rooms '(0 1 2 3 4 5 6 7 8 9 10 11 12 13 24 25 26 27 28 58 59
		     60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76
		     77 78 79 80 81 82 83))

(setq dun-verblist '((die . dun-die) (ne . dun-ne) (north . dun-n) 
		     (south . dun-s) (east . dun-e) (west . dun-w)
		     (u . dun-up) (d . dun-down) (i . dun-inven)
		     (inventory . dun-inven) (look . dun-examine) (n . dun-n)
		     (s . dun-s) (e . dun-e) (w . dun-w) (se . dun-se)
		     (nw . dun-nw) (sw . dun-sw) (up . dun-up) 
		     (down . dun-down) (in . dun-in) (out . dun-out)
		     (go . dun-go) (drop . dun-drop) (southeast . dun-se)
		     (southwest . dun-sw) (northeast . dun-ne)
		     (northwest . dun-nw) (save . dun-save-game)
		     (restore . dun-restore) (long . dun-long) (dig . dun-dig)
		     (shake . dun-shake) (wave . dun-shake)
		     (examine . dun-examine) (describe . dun-examine) 
		     (climb . dun-climb) (eat . dun-eat) (put . dun-put)
		     (type . dun-type)  (insert . dun-put)
		     (score . dun-score) (help . dun-help) 
                     (helpeng . dun-helpeng) (helpunix . dun-helpunix) 
                     (helpverb . dun-helpverb)
                     (helpdos . dun-helpdos) (quit . dun-quit) 
		     (read . dun-examine) (verbose . dun-long) 
		     (urinate . dun-piss) (piss . dun-piss)
		     (flush . dun-flush) (sleep . dun-sleep) (lie . dun-sleep) 
		     (x . dun-examine) (break . dun-break) (drive . dun-drive)
		     (board . dun-in) (enter . dun-in) (turn . dun-turn)
		     (press . dun-press) (push . dun-press) (swim . dun-swim)
		     (on . dun-in) (off . dun-out) (chop . dun-break)
		     (switch . dun-press) (cut . dun-break) (exit . dun-out)
		     (leave . dun-out) (reset . dun-power) (flick . dun-press)
		     (superb . dun-superb) (answer . dun-answer)
		     (throw . dun-drop) (l . dun-examine) (take . dun-take)
		     (get . dun-take) (feed . dun-feed)))

(setq dun-inbus nil)
(setq dun-nomail nil)
(setq dun-ignore '(the to at))
(setq dun-mode 'moby)
(setq dun-sauna-level 0)

(defconst north 0)
(defconst south 1)
(defconst east 2)
(defconst west 3)
(defconst northeast 4)
(defconst southeast 5)
(defconst northwest 6)
(defconst southwest 7)
(defconst up 8)
(defconst down 9)
(defconst in 10)
(defconst out 11)

(setq dungeon-map '(
;		      no  so  ea  we  ne  se  nw  sw  up  do  in  ot
		    ( 96  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;0
		    ( -1  -1   2  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;1
		    ( -1  -1   3   1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;2
		    ( -1  -1  -1   2   4   6  -1  -1  -1  -1  -1  -1 ) ;3
		    ( -1  -1  -1  -1   5  -1  -1   3  -1  -1  -1  -1 ) ;4
		    ( -1  -1  -1  -1  255 -1  -1   4  -1  -1  255 -1 ) ;5
		    ( -1  -1  -1  -1  -1   7   3  -1  -1  -1  -1  -1 ) ;6
		    ( -1  -1  -1  -1  -1  255  6  27  -1  -1  -1  -1 ) ;7
		    ( 255  5   9  10  -1  -1  -1   5  -1  -1  -1   5 ) ;8
		    ( -1  -1  -1   8  -1  -1  -1  -1  -1  -1  -1  -1 ) ;9
		    ( -1  -1   8  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;10
		    ( -1   8  -1  58  -1  -1  -1  -1  -1  -1  -1  -1 ) ;11
		    ( -1  -1  13  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;12
		    ( 15  -1  14  12  -1  -1  -1  -1  -1  -1  -1  -1 ) ;13
		    ( -1  -1  -1  13  -1  -1  -1  -1  -1  -1  -1  -1 ) ;14
		    ( -1  13  16  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;15
		    ( -1  -1  -1  15  -1  -1  -1  -1  -1  17  16  -1 ) ;16
		    ( -1  -1  17  17  17  17 255  17 255  17  -1  -1 ) ;17
		    ( 18  18  18  18  18  -1  18  18  19  18  -1  -1 ) ;18
		    ( -1  18  18  19  19  20  19  19  -1  18  -1  -1 ) ;19
		    ( -1  -1  -1  18  -1  -1  -1  -1  -1  21  -1  -1 ) ;20
		    ( -1  -1  -1  -1  -1  20  22  -1  -1  -1  -1  -1 ) ;21
		    ( 18  18  18  18  16  18  23  18  18  18  18  18 ) ;22
		    ( -1 255  -1  -1  -1  19  -1  -1  -1  -1  -1  -1 ) ;23
		    ( 23  25  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;24
		    ( 24 255  -1  -1  -1  -1  -1  -1  -1  -1 255  -1 ) ;25
		    (255  28  -1  -1  -1  -1  -1  -1  -1  -1 255  -1 ) ;26
		    ( -1  -1  -1  -1   7  -1  -1  -1  -1  -1  -1  -1 ) ;27
		    ( 26 255  -1  -1  -1  -1  -1  -1  -1  -1  255 -1 ) ;28
		    ( -1  -1  30  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;29
		    ( -1  -1  31  29  -1  -1  -1  -1  -1  -1  -1  -1 ) ;30
		    ( 32  33  -1  30  -1  -1  -1  -1  -1  -1  -1  -1 ) ;31
		    ( -1  31  -1  255 -1  -1  -1  -1  -1  34  -1  -1 ) ;32
		    ( 31  -1  -1  -1  -1  -1  -1  -1  -1  35  -1  -1 ) ;33
		    ( -1  35  -1  -1  -1  -1  -1  -1  32  37  -1  -1 ) ;34
		    ( 34  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;35
		    ( -1  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;36
		    ( -1  -1  -1  -1  -1  -1  -1  38  34  -1  -1  -1 ) ;37
		    ( -1  -1  40  41  37  -1  -1  39  -1  -1  -1  -1 ) ;38
		    ( -1  -1  -1  -1  38  -1  -1  -1  -1  -1  -1  -1 ) ;39
		    ( -1  -1  -1  38  -1  -1  -1  -1  42  -1  -1  -1 ) ;40
		    ( -1  -1  38  -1  -1  -1  -1  -1  -1  43  -1  -1 ) ;41
		    ( -1  -1  -1  -1  -1  -1  -1  -1  -1  40  -1  -1 ) ;42
		    ( 44  -1  46  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;43
		    ( -1  43  45  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;44
		    ( -1  46  -1  44  -1  -1  -1  -1  -1  -1  -1  -1 ) ;45
		    ( 45  -1  -1  43  -1  -1  -1  -1  -1  255 -1  -1 ) ;46
		    ( 48  50  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;47
		    ( 49  47  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;48
		    ( -1  48  -1  -1  -1  -1  -1  -1  52  -1  -1  -1 ) ;49
		    ( 47  51  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;50
		    ( 50  104 -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;51
		    ( -1  -1  -1  -1  -1  -1  -1  -1  53  49  -1  -1 ) ;52
		    ( -1  -1  -1  -1  -1  -1  -1  -1  54  52  -1  -1 ) ;53
		    ( -1  -1  -1  -1  55  -1  -1  -1  -1  53  -1  -1 ) ;54
		    ( -1  -1  -1  -1  56  -1  -1  54  -1  -1  -1  54 ) ;55
		    ( -1  -1  -1  -1  -1  -1  -1  55  -1  31  -1  -1 ) ;56
		    ( -1  -1  32  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;57
		    ( 59  -1  11  -1  -1  -1  -1  -1  -1  -1  255 255) ;58
		    ( 60  58  63  -1  -1  -1  255 -1  -1  -1  255 255) ;59
		    ( 61  59  64  -1  -1  -1  -1  -1  -1  -1  255 255) ;60
		    ( 62  60  65  -1  -1  -1  -1  -1  -1  -1  255 255) ;61
		    ( -1  61  66  -1  -1  -1  -1  -1  -1  -1  255 255) ;62
		    ( 64  -1  67  59  -1  -1  -1  -1  -1  -1  255 255) ;63
		    ( 65  63  68  60  -1  -1  -1  -1  -1  -1  255 255) ;64
		    ( 66  64  69  61  -1  -1  -1  -1  -1  -1  255 255) ;65
		    ( -1  65  70  62  -1  -1  -1  -1  -1  -1  255 255) ;66
		    ( 68  -1  71  63  -1  -1  -1  -1  -1  -1  255 255) ;67
		    ( 69  67  72  64  -1  -1  -1  -1  -1  -1  255 255) ;68
		    ( 70  68  73  65  -1  -1  -1  -1  -1  -1  255 255) ;69
		    ( -1  69  74  66  -1  -1  -1  -1  -1  -1  255 255) ;70
		    ( 72  -1  75  67  -1  -1  -1  -1  -1  -1  255 255) ;71
		    ( 73  71  76  68  -1  -1  -1  -1  -1  -1  255 255) ;72
		    ( 74  72  77  69  -1  -1  -1  -1  -1  -1  255 255) ;73
		    ( -1  73  78  70  -1  -1  -1  -1  -1  -1  255 255) ;74
		    ( 76  -1  79  71  -1  -1  -1  -1  -1  -1  255 255) ;75
		    ( 77  75  80  72  -1  -1  -1  -1  -1  -1  255 255) ;76
		    ( 78  76  81  73  -1  -1  -1  -1  -1  -1  255 255) ;77
		    ( -1  77  82  74  -1  -1  -1  -1  -1  -1  255 255) ;78
		    ( 80  -1  -1  75  -1  -1  -1  -1  -1  -1  255 255) ;79
		    ( 81  79  255 76  -1  -1  -1  -1  -1  -1  255 255) ;80
		    ( 82  80  -1  77  -1  -1  -1  -1  -1  -1  255 255) ;81
		    ( -1  81  -1  78  -1  -1  -1  -1  -1  -1  255 255) ;82
		    ( 84  -1  -1  -1  -1  59  -1  -1  -1  -1  255 255) ;83
		    ( -1  83  85  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;84
		    ( 86  -1  87  84  -1  -1  -1  -1  -1  -1  -1  -1 ) ;85
		    ( -1  85  88  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;86
		    ( 88  -1  -1  85  -1  -1  -1  -1  -1  -1  -1  -1 ) ;87
		    ( -1  87 255  86  -1  -1  -1  -1  -1  -1  -1  -1 ) ;88
		    ( -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 255  -1 ) ;89
		    ( 91  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;90
		    ( 92  90  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;91
		    ( -1  91  -1  -1  -1  -1  -1  -1  93  94  -1  -1 ) ;92
		    ( -1  -1  -1  88  -1  -1  -1  -1  -1  92  -1  -1 ) ;93
		    ( -1  -1  -1  -1  95  -1  -1  -1  92  -1  -1  -1 ) ;94
		    ( -1  -1  -1  -1  -1  -1  -1  94  -1  -1  -1  -1 ) ;95
		    ( 97   0  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;96
		    ( -1  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;97
		    ( 99  97  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;98
		    ( -1  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;99
		    ( 101 99  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;100
		    ( -1  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;101
		    ( 103 101 -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;102
		    ( -1  102 -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;103
		    ( 51  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1  -1 ) ;104
		    )
;		      no  so  ea  we  ne  se  nw  sw  up  do  in  ot
)


;;; How the user references *all* objects, permanent and regular.
(setq dun-objnames '(
		 (shovel . 0) 
		 (lamp . 1)
		 (cpu . 2) (board . 2) (card . 2) (chip . 2)
		 (food . 3) 
		 (key . 4) 
		 (paper . 5) (slip . 5)
		 (rms . 6) (statue . 6) (statuette . 6)  (stallman . 6)
		 (diamond . 7)
		 (weight . 8)
		 (life . 9) (preserver . 9)
		 (bracelet . 10) (emerald . 10) 
		 (gold . 11)
		 (platinum . 12)
		 (towel . 13) (beach . 13)
		 (axe . 14)
		 (silver . 15)
		 (license . 16)
		 (coins . 17)
		 (egg . 18)
		 (jar . 19)
		 (bone . 20)
		 (acid . 21) (nitric . 21)
		 (glycerine . 22)
		 (ruby . 23)
		 (amethyst . 24) 
		 (mona . 25)
		 (bill . 26) 
		 (floppy . 27) (disk . 27)
		 
		 (boulder . -1)
		 (tree . -2) (trees . -2) (palm . -2) 
		 (bear . -3)
		 (bin . -4) (bins . -4)
		 (cabinet . -5) (computer . -5) (vax . -5) (ibm . -5) 
		 (protoplasm . -6)
		 (dial . -7) 
		 (button . -8) 
		 (chute . -9) 
		 (painting . -10)
		 (bed . -11)
		 (urinal . -12)
		 (URINE . -13)
		 (pipes . -14) (pipe . -14) 
		 (box . -15) (slit . -15) 
		 (cable . -16) (ethernet . -16) 
		 (mail . -17) (drop . -17)
		 (bus . -18)
		 (gate . -19)
		 (cliff . -20) 
		 (skeleton . -21) (dinosaur . -21)
		 (fish . -22)
		 (tanks . -23) (tank . -23)
		 (switch . -24)
		 (blackboard . -25)
		 (disposal . -26) (garbage . -26)
		 (ladder . -27)
		 (subway . -28) (train . -28) 
		 (pc . -29) (drive . -29) (coconut . -30) (coconuts . -30)
		 (lake . -32) (water . -32)
))

(dolist (x dun-objnames)
  (let (name)
    (setq name (concat "obj-" (prin1-to-string (car x))))
    (eval (list 'defconst (intern name) (cdr x)))))

(defconst obj-special 255)

;;; The initial setup of what objects are in each room.
;;; Regular objects have whole numbers lower than 255.
;;; Objects that cannot be taken but might move and are
;;; described during room description are negative.
;;; Stuff that is described and might change are 255, and are
;;; handled specially by 'dun-describe-room. 

(setq dun-room-objects (list nil 

        (list obj-shovel)                     ;; treasure-room
        (list obj-boulder)                    ;; dead-end
        nil nil nil
        (list obj-food)                       ;; se-nw-road
        (list obj-bear)                       ;; bear-hangout
        nil nil
        (list obj-special)                    ;; computer-room
        (list obj-lamp obj-license obj-silver);; meadow
        nil nil
        (list obj-special)                    ;; sauna
        nil 
        (list obj-weight obj-life)            ;; weight-room
        nil nil
        (list obj-rms obj-floppy)             ;; thirsty-maze
        nil nil nil nil nil nil nil 
        (list obj-emerald)                    ;; hidden-area
        nil
        (list obj-gold)                       ;; misty-room
        nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil
        (list obj-towel obj-special)          ;; red-room
        nil nil nil nil nil
        (list obj-box)                        ;; stair-landing
        nil nil nil
        (list obj-axe)                        ;; smal-crawlspace
        nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil
        nil nil nil nil nil
        (list obj-special)                    ;; fourth-vermont-intersection
        nil nil
        (list obj-coins)                      ;; fifth-oaktree-intersection
        nil
        (list obj-bus)                        ;; fifth-sycamore-intersection
        nil
        (list obj-bone)                       ;; museum-lobby
        nil
        (list obj-jar obj-special obj-ruby)   ;; marine-life-area
        (list obj-nitric)                     ;; maintenance-room
        (list obj-glycerine)                  ;; classroom
        nil nil nil nil nil
        (list obj-amethyst)                   ;; bottom-of-subway-stairs
        nil nil
        (list obj-special)                    ;; question-room-1
        nil
        (list obj-special)                    ;; question-room-2
        nil
        (list obj-special)                    ;; question-room-three
        nil
        (list obj-mona)                       ;; winner's-room
nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil
nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil
nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil
nil))

;;; These are objects in a room that are only described in the
;;; room description.  They are permanent.

(setq dun-room-silents (list nil
        (list obj-tree obj-coconut)            ;; dead-end
        (list obj-tree obj-coconut)            ;; e-w-dirt-road
        nil nil nil nil nil nil
        (list obj-bin)                         ;; mailroom
        (list obj-computer)                    ;; computer-room
        nil nil nil
        (list obj-dial)                        ;; sauna
        nil
        (list obj-ladder)                      ;; weight-room
        (list obj-button obj-ladder)           ;; maze-button-room
        nil nil nil
        nil nil nil nil
	(list obj-lake)                        ;; lakefront-north
	(list obj-lake)                        ;; lakefront-south
	nil
        (list obj-chute)                       ;; cave-entrance
        nil nil nil nil nil
        (list obj-painting obj-bed)            ;; bedroom
        (list obj-urinal obj-pipes)            ;; bathroom
        nil nil nil nil nil nil
        (list obj-boulder)                     ;; horseshoe-boulder-room
        nil nil nil nil nil nil nil nil nil nil nil nil nil nil
        (list obj-computer obj-cable)          ;; gamma-computing-center
        (list obj-mail)                        ;; post-office
        (list obj-gate)                        ;; main-maple-intersection
        nil nil nil nil nil nil nil nil nil nil nil nil nil
        nil nil nil nil nil nil nil
        (list obj-cliff)                       ;; fifth-oaktree-intersection
        nil nil nil
        (list obj-dinosaur)                    ;; museum-lobby
        nil
        (list obj-fish obj-tanks)              ;; marine-life-area
        (list obj-switch)                      ;; maintenance-room
        (list obj-blackboard)                  ;; classroom
        (list obj-train)                       ;; vermont-station
        nil nil
        (list obj-disposal)                    ;; north-end-of-n-s-tunnel
        nil nil
        (list obj-computer)                    ;; endgame-computer-room
        nil nil nil nil nil nil nil nil 
	(list obj-pc)                          ;; pc-area
	nil nil nil nil nil nil
))
(setq dun-inventory '(1))

;;; Descriptions of objects, as they appear in the room description, and
;;; the inventory.

(setq dun-objects '(
		("ɂ̓Vxishovelj܂D" "Vx shovel")                ;0
		("ɂ̓v(lamp)܂B" "v lamp")                  ;1
		("ɂ͂bot{[h(board)܂D" "bot{[h board")      ;2
		("ɂ͐Hו(food)Ă܂." "Hו food")              ;3
		("ɂ͋P̌(key)܂B" " key")    ;4
		("ɂ͎؂(paper)܂B" "؂ paper")  ;5
		("ɂ `[hXg[}̂낤l`(statue)܂B" ;6
		 "낤l` statue")
		("ɂ͋P_CAh(diamond)܂B" "_CAh diamond")   ;7
		("ɂ 10 |h̓SAC(weight)܂B" "SAC weight")       ;8
		("ɂ͋~(life preserver)܂B" "~ preserver");9
		("ɂ̓Gh̘r(bracelet)܂B" "r bracelet")   ;10
		("ɂ͋̉ז_(gold)܂B" "̉ז_ gold")            ;11
		("ɂ̓v`ỉז_(platinum)܂B" "v`ỉז_ platinum")    ;12
		("nʂ̏Ƀr[`^I(towel)Ă܂B" "^I towel")
		("ɂ͕(axe)܂B" " axe") ;14
		("ɂ͋̉ז_(silver)܂B" "̉ז_ silver")  ;15
		("ɂ̓oX̉^]Ƌ(license)܂B" "^]Ƌ license") ;16
		("ɂ͋Mdȋ(coins)܂B" "Mdȋ coins")
		("ɂ͕΂΂߂ꂽk(egg)܂B" "Mdȗ egg") ;18
		("ɂ̓KX̂т(jar)܂B" "т jar") ;19
		("ɂ͋̍(bone)܂B" " bone") ;20
		("ɂ͂PpbN̏Ɏ_(acid)܂B" "Ɏ_ acid")
		("ɂ͂PpbÑOZ(glycerine)܂B" "OZ glycerine") ;22
		("ɂ͋Mdȃr[(ruby)܂B" "r[ ruby") ;23
		("ɂ͋MdȎ(amethyst)܂B" " amethyst") ;24
		("ɂ̓iUiMona Lisaj܂B" "iU Mona") ;25
		("ɂ100h̎(bill)܂B" "100h bill") ;26
		("ɂ̓tbs[fBXN(disk)܂B" "fBXN disk") ;27
	       )
)

;;; Weight of objects

(setq dun-object-lbs 
      '(2 1 1 1 1 0 2 2 10 3 1 1 1 0 1 1 0 1 1 1 1 0 0 2 2 1 0 0))
(setq dun-object-pts 
      '(0 0 0 0 0 0 0 10 0 0 10 10 10 0 0 10 0 10 10 0 0 0 0 10 10 10 10 0))


;;; Unix representation of objects.
(setq dun-objfiles '(
		 "shovel.o" "lamp.o" "cpu.o" "food.o" "key.o" "paper.o"
		 "rms.o" "diamond.o" "weight.o" "preserver.o" "bracelet.o"
		 "gold.o" "platinum.o" "towel.o" "axe.o" "silver.o" "license.o"
		 "coins.o" "egg.o" "jar.o" "bone.o" "nitric.o" "glycerine.o"
		 "ruby.o" "amethyst.o"
		 ))

;;; These are the descriptions for the negative numbered objects from
;;; dun-room-objects

(setq dun-perm-objects '(
		     nil
		     ("ɂ͑傫Ȋې(boulder)܂B")
		     nil
		     ("ɂ͋낵Fibearj܂I")
		     nil
		     nil
		     ("ɂ͉l̂Ȃ(protoplasm)̎R܂B")
		     nil
		     nil
		     nil
		     nil
		     nil
		     nil
		     ("͊̕ȓ(strange smell)܂B")
		     nil
		     (
"ɂ̓Xbĝ锠(box)AǂɃ{gŗ߂Ă܂B"
                     )
		     nil
		     nil
		     ("ɂ̓oX(bus)܂B")
		     nil
		     nil
		     nil
))


;;; These are the descriptions the user gets when regular objects are
;;; examined.

(setq dun-physobj-desc '(
" $19.99ƏꂽlD̂Aӂ̃VxłB"
"̓[xbg(Geppetto)ɂ̃vłB"
"bot{[hɂ VAX ̃`bvĂ܂B 2 KoCg̃I{[h
q`lĂ悤Ɍ܂B"
"͉̓̂悤Ɍ܂BЂǂLɂ܂B"
nil
"ɂ͂Ă܂Bu߂Ƃ 'help'ƃ^Cv邱Ƃ
YȂƁBāA̒PoĂ 'worms'v"
"̐l`́AL EMACSGfB^̍҃`[hEXg[}
(Richard Stallman)ɎĂ܂BȂ́AނC͂ĂȂƂ
C܂B"
nil
"Ȃ͓SACdƂmF܂B"
"ɂ rȑiS.S.MinnowjƏĂ܂."
nil
nil
nil
"̓Xk[s[(snoopy)̏ꂽGłB"
nil
nil
"ɂ͂Ȃ̎ʐ^tĂ܂I"
"19I瑱Â݂łB"
"͍ Fabrege ̗łB"
"͎fȃKX̃rłB"
nil
nil
nil
nil
nil
                     )
)

;;; These are the descriptions the user gets when non-regular objects
;;; are examined.

(setq dun-permobj-desc '(
		     nil
"͂̐(boulder)łB𓮂Ƃ͂ł܂B"
"̓V̎(coconut)LxɋĂ郄V̖؁XłB"
"̓OY[(grizzly)̈̂悤Ɍ܂B"
"唠͑SċłB悭ƁAȂ͑唠̒ɖO
̂킩܂BAقƂǂ̖O͂Ă܂Ă
ǂނƂł܂BȂǂނƂł͎̂̂R
OłB
              WFt[ER[     Jeffrey Collier
              o[gEgNh   Robert Toukmond
              g[}XEXgbN     Thomas Stock
"
                      nil
"͂ႲƂ̂łB"
"_CA͂ƈȑOɂďĂ܂x̖ڐwĂ܂B"
nil
nil
"́AGrXEvX[(Elvis Presley)̃xxbg̊GłB
͕ǂɂőłtĂ̂AƂł܂B"
"͂ƂĂ}bgX̍dNC[TCỸxbhłB"
"֊͓A̒̂ق̂ǂꂢłB̃Tr܂B
m߂邽߂ɋ߂ÂƁAȂ͒̔raȂApCv̂ǂւ
ȂĂȂ傫Ȍ邱ƂɋC܂B
̌͐lɂ͂܂ɂłB(flush)邽߂̃nh
ƂĂꂢŁAȂ͂̒Ɏ̎pf̂邱Ƃł܂B"
nil
nil
"̏ʂɂ̓Xbg(slit)Ȁɉő菑Ă܂B
u(key)̍XVB̒Ɍ}(put)Bv"
nil
"ɂ́uB(express mail)ƏĂ܂B"
"35l̃oXŁAʂɁu[r[cA[Y(mobytours)vƂЖ
Ă܂B"
"͏z(climb)ɂ͂܂ɂȋ̖łB"
"͂ƂĂȂȊRłB"
"cOȂAȂɂăE`NqׂقǏ\Ȓm͎
܂BɂA͂ƂĂ傫łB"
"̋́AĂ͂ƂĂ悤Ɍ܂B"
nil
nil
nil
nil
"ivɌɎtꂽ܂܂́Aʂ̃nVSłB"
"͏ôłĂq(train)łB"
"tbs[fBXNhCu(floppy disk drive)ЂƂ
p[\iRs[^(computer)łB"
		    )
)

(setq dun-diggables 
      (list nil nil nil (list obj-cpu) nil nil nil nil nil nil nil
		  nil nil nil nil nil nil nil nil nil nil      ;11-20
		  nil nil nil nil nil nil nil nil nil nil      ;21-30
		  nil nil nil nil nil nil nil nil nil nil      ;31-40
		  nil (list obj-platinum) nil nil nil nil nil nil nil nil))

(setq dun-room-shorts nil)
(dolist (x dun-rooms)
  (setq dun-room-shorts  
		     (append dun-room-shorts (list (downcase 
						    (dun-space-to-hyphen
						     (cadr x)))))))

(setq dun-endgame-questions '(
			  ("-1" "foo")
			  ("00" "robert")
			  ("01" "foo")
			  ("02" "4" "four")
			  ("03" "toukmond")
			  ("04" "20" "twenty")
			  ("05" "mobytours")
			  ("06" "collier" "stock")
			  ("07" "snoopy")
			  ("08" "stallman")
			  ("09" "2")
			  ("10" "vermont")
			  ("11" "ten" "10")
			  ("12" "fourth" "4" "4th")
			  ("13" "24" "twentyfour" "twenty-four")
			  ("14" "grizzly")
			  ("15" "cpu" "card" "vax" "board" "platinum")
			  ("16" "tcp/ip" "ip" "tcp")
))

(setq dun-endgame-questions-msg '(
			  ("-1".
" ͂܂B'answer foo' Ɠ͂ĂB.")
			  ("00".
"'pokey'Ƃ΂}Vł̂Ȃ̃pX[h͉H")
			  ("01".
"gamma̓ianonymousjftpł̂Ȃ̃pX[h͉H")
			  ("02".
"endgameAȂ_𓾂邽߂ɕ󕨂(put)Ƃł
ꏊ͂H")
			  ("03".
"'endgame'}Vł̂Ȃ̃[UOC͉H")
			  ("04".
"Vx̒li͂悻hHiœ́j")
			  ("05".
"XoX̉Ж͉H")
			  ("06".
"X֕̕ɂ̂ꂽAȂȊÔQl̖ÔAǂ炩
Xgl[i㔼̖Oj𓚂B")
			  ("07".
"^IɏĂ}K̃LN^[͉H")
			  ("08".
"EMACS ̊J҂̃Xgl[i㔼̖Oj͉H")
			  ("09".
"VaxCPU{[h(board)ɂ̂Ă͉KoCgHiœ́j")
			  ("10".
"AJ̏B̖O̒ʂ̖ÓH")
			  ("11".
"SAC̏d͉|hHiœ́j")
			  ("12".
"nS̉ŵ͑扽ʂHiœ́j")
			  ("13".
"X֋ǂAX̌_iTH,LH܂ށj͂Hiœ́j")
			  ("14".
"BĂF͉̎ނH")
			  ("15".
"Ȃ@Ă݂̂AЂƂ̖O𓚂B")
			  ("16".
"pockygammåԂŎgĂlbg[NʐMvgR͉H")
))

(let (a)
  (setq a 0)
  (dolist (x dun-room-shorts)
    (eval (list 'defconst (intern x) a))
    (setq a (+ a 1))))



;;;;
;;;; This section defines the UNIX emulation functions for dunnet.
;;;;

(defun dun-unix-parse (args)
  (interactive "*p")
  (beginning-of-line)
  (let (beg esign)
    (setq beg (+ (point) 2))
    (end-of-line)
    (if (and (not (= beg (point)))
	     (string= "$" (buffer-substring (- beg 2) (- beg 1))))
	(progn
	  (setq line (downcase (buffer-substring beg (point))))
	  (princ line)
	  (if (eq (dun-parse2 nil dun-unix-verbs line) -1)
	      (progn
		(if (setq esign (string-match "=" line))
		    (dun-doassign line esign)		
		  (dun-mprinc (car line-list))
		  (dun-mprincl ": not found.iR}h܂j")))))
      (goto-char (point-max))
      (dun-mprinc "\n"))
    (if (eq dungeon-mode 'unix)
	(progn
	  (dun-fix-screen)
	  (dun-mprinc "$ ")))))

(defun dun-doassign (line esign)
  (if (not dun-wizard)
      (let (passwd)
	(dun-mprinc "Enter wizard password: ")
	(setq passwd (dun-read-line))
	(if (not dun-batch-mode)
	    (dun-mprinc "\n"))
	(if (string= passwd "moby")
	    (progn
	      (setq dun-wizard t)
	      (dun-doassign line esign))
	  (dun-mprincl "Incorrect.")))

    (let (varname epoint afterq i value)
      (setq varname (substring line 0 esign))
      (if (not (setq epoint (string-match ")" line)))
	  (if (string= (substring line (1+ esign) (+ esign 2))
		       "\"")
	      (progn
		(setq afterq (substring line (+ esign 2)))
		(setq epoint (+
			      (string-match "\"" afterq)
			      (+ esign 3))))
	    
	    (if (not (setq epoint (string-match " " line)))
		(setq epoint (length line))))
	(setq epoint (1+ epoint))
	(while (and
		(not (= epoint (length line)))
		(setq i (string-match ")" (substring line epoint))))
	  (setq epoint (+ epoint i 1))))
      (setq value (substring line (1+ esign) epoint))
      (dun-eval varname value))))

(defun dun-eval (varname value)
  (let (eval-error)
    (switch-to-buffer (get-buffer-create "*dungeon-eval*"))
    (erase-buffer)
    (insert "(setq ")
    (insert varname)
    (insert " ")
    (insert value)
    (insert ")")
    (setq eval-error nil)
    (condition-case nil
	(eval-current-buffer)
      (error (setq eval-error t)))
    (kill-buffer (current-buffer))
    (switch-to-buffer "*dungeon*")
    (if eval-error
	(dun-mprincl "Invalid syntax."))))
  

(defun dun-unix-interface ()
  (dun-login)
  (if dun-logged-in
      (progn
	(setq dungeon-mode 'unix)
	(define-key dungeon-mode-map "\r" 'dun-unix-parse)
	(dun-mprinc "$ "))))

(defun dun-login ()
  (let (tries username password)
    (setq tries 4)
    (while (and (not dun-logged-in) (> (setq tries (- tries 1)) 0))
      (dun-mprinc "\n\nUNIX System V, Release 2.2 (pokey)\n\nlogin: ")
      (setq username (dun-read-line))
      (if (not dun-batch-mode)
	  (dun-mprinc "\n"))
      (dun-mprinc "password: ")
      (setq password (dun-read-line))
      (if (not dun-batch-mode)
	  (dun-mprinc "\n"))
      (if (or (not (string= username "toukmond"))
	      (not (string= password "robert")))
	  (dun-mprincl "login incorrect")
	(setq dun-logged-in t)
	(dun-mprincl "
Welcome to Unix\n
Please clean up your directories.  The filesystem is getting full.
ifBNg𐮗Bt@CVXe͂ςɂȂĂBj
Our tcp/ip link to gamma is a little flaky, but seems to work.
iRs[^ gamma ւTCP/IPɂ郊N͕s肾삷Bj
The current version of ftp can only send files from your home
directory, and deletes them after they are sent!  Be careful.
it@C]\tg ftp ݂̌̃o[ẂAz[fBNg
  ̃t@CM̂݉\Bt@C͑MɏIӂBj

Note: Restricted bourne shell in use.iꂽbourne shell쒆j
it@C̈ꗗɂ R}h ls g܂j\n")))
  (setq dungeon-mode 'dungeon)))

(defun dun-ls (args)
  (if (car args)
      (let (ocdpath ocdroom)
	(setq ocdpath dun-cdpath)
	(setq ocdroom dun-cdroom)
	(if (not (eq (dun-cd args) -2))
	    (dun-ls nil))
	(setq dun-cdpath ocdpath)
	(setq dun-cdroom ocdroom))
    (if (= dun-cdroom -10)
	(dun-ls-inven))
    (if (= dun-cdroom -2)
	(dun-ls-rooms))
    (if (= dun-cdroom -3)
	(dun-ls-root))
    (if (= dun-cdroom -4)
	(dun-ls-usr))
    (if (> dun-cdroom 0)
	(dun-ls-room))))

(defun dun-ls-root ()
  (dun-mprincl "total 4
drwxr-xr-x  3 root     staff           512 Jan 1 1970 .
drwxr-xr-x  3 root     staff          2048 Jan 1 1970 ..
drwxr-xr-x  3 root     staff          2048 Jan 1 1970 usr
drwxr-xr-x  3 root     staff          2048 Jan 1 1970 rooms"))

(defun dun-ls-usr ()
  (dun-mprincl "total 4
drwxr-xr-x  3 root     staff           512 Jan 1 1970 .
drwxr-xr-x  3 root     staff          2048 Jan 1 1970 ..
drwxr-xr-x  3 toukmond restricted      512 Jan 1 1970 toukmond"))

(defun dun-ls-rooms ()
  (dun-mprincl "total 16
drwxr-xr-x  3 root     staff           512 Jan 1 1970 .
drwxr-xr-x  3 root     staff          2048 Jan 1 1970 ..")
  (dolist (x dun-visited)
    (dun-mprinc
"drwxr-xr-x  3 root     staff           512 Jan 1 1970 ")
    (dun-mprincl (nth x dun-room-shorts))))

(defun dun-ls-room ()
  (dun-mprincl "total 4
drwxr-xr-x  3 root     staff           512 Jan 1 1970 .
drwxr-xr-x  3 root     staff          2048 Jan 1 1970 ..
-rwxr-xr-x  3 root     staff          2048 Jan 1 1970 description")
  (dolist (x (nth dun-cdroom dun-room-objects))
    (if (and (>= x 0) (not (= x 255)))
	(progn
	  (dun-mprinc "-rwxr-xr-x  1 toukmond restricted        0 Jan 1 1970 ")
	  (dun-mprincl (nth x dun-objfiles))))))

(defun dun-ls-inven ()
  (dun-mprinc "total 467
drwxr-xr-x  3 toukmond restricted      512 Jan 1 1970 .
drwxr-xr-x  3 root     staff          2048 Jan 1 1970 ..")
  (dolist (x dun-unix-verbs)
    (if (not (eq (car x) 'IMPOSSIBLE))
	(progn
	  (dun-mprinc"
-rwxr-xr-x  1 toukmond restricted    10423 Jan 1 1970 ")
	  (dun-mprinc (car x)))))
  (dun-mprinc "\n")
  (if (not dun-uncompressed)
      (dun-mprincl
"-rwxr-xr-x  1 toukmond restricted        0 Jan 1 1970 paper.o.Z"))
  (dolist (x dun-inventory)
    (dun-mprinc 
"-rwxr-xr-x  1 toukmond restricted        0 Jan 1 1970 ")
    (dun-mprincl (nth x dun-objfiles))))

(defun dun-echo (args)
  (let (nomore var)
    (setq nomore nil)
    (dolist (x args)
	    (if (not nomore)
		(progn
		  (if (not (string= (substring x 0 1) "$"))
		      (progn
			(dun-mprinc x)
			(dun-mprinc " "))
		    (setq var (intern (substring x 1)))
		    (if (not (boundp var))
			(dun-mprinc " ")
		      (if (member var dun-restricted)
			  (progn
			    (dun-mprinc var)
			    (dun-mprinc ": Permission denied")
			    (setq nomore t))
			(eval (list 'dun-mprinc var))
			(dun-mprinc " ")))))))
	    (dun-mprinc "\n")))


(defun dun-ftp (args)
  (let (host username passwd ident newlist)
    (if (not (car args))
	(dun-mprincl "ftp: hostname required on command line.
iR}ȟɐڑRs[^KvB ftp <Rs[^> j")
      (setq host (intern (car args)))
      (if (not (member host '(gamma dun-endgame)))
	  (dun-mprincl "ftp: Unknown host.iftp:sȃzXgj")
	(if (eq host 'dun-endgame)
	    (dun-mprincl "ftp: connection to endgame not allowed
iftp: endgameftpɂڑĂȂj")
	  (if (not dun-ethernet)
	      (dun-mprincl "ftp: host not responding.iftp:zXg̉Ȃj")
	    (dun-mprincl "Connected to gamma. FTP ver 0.9 00:00:00 01/01/70
i gamma ֐ڑBFTP o[W 0.9 j")
	    (dun-mprinc "Usernamei[Uj: ")
	    (setq username (dun-read-line))
	    (if (string= username "toukmond")
		(if dun-batch-mode
		    (dun-mprincl "toukmond ftp access not allowed.
itoukmond̃ANZX͕sj")
		  (dun-mprincl "\ntoukmond ftp access not allowed.
itoukmond̃ANZX͕sj"))
	      (if (string= username "anonymous")
		  (if dun-batch-mode
		      (dun-mprincl
		       "Guest login okay, send your user ident as password.
iQXgOCnjApX[h̑ɂȂ̃[U[𑗐Mj")
		    (dun-mprincl 
		     "\nGuest login okay, send your user ident as password.
iQXgOCnjApX[h̑ɂȂ̃[U[𑗐Mj"))
		(if dun-batch-mode
		    (dun-mprinc "Password required for ")
		  (dun-mprinc "\nPassword required for "))
		(dun-mprincl username)
	        (dun-mprincl (format "i[U %s ̃pX[hKvj" username)))
	      (dun-mprinc "Password: ")
	      (setq ident (dun-read-line))
	      (if (not (string= username "anonymous"))
		  (if dun-batch-mode
		      (dun-mprincl "Login failed.iOCsj")
		    (dun-mprincl "\nLogin failed.iOCsj"))
		(if dun-batch-mode
		   (dun-mprincl 
		    "Guest login okay, user access restrictions apply.
iQXgOCnjC[UANZXKpj")
		  (dun-mprincl 
		   "\nGuest login okay, user access restrictions apply.
iQXgOCnjC[UANZXKpj"))
		(dun-ftp-commands)
;		(setq newlist 
;'("What password did you use during anonymous ftp to gamma?"))
		(setq newlist '("01"))
		(setq newlist (append newlist (list ident)))
		(rplaca (nthcdr 1 dun-endgame-questions) newlist)))))))))
  
(defun dun-ftp-commands ()
    (setq dun-exitf nil)
    (let (line)
      (while (not dun-exitf)
	(dun-mprinc "ftp> ")
	(setq line (dun-read-line))
	(if 
	    (eq
	     (dun-parse2 nil 
		    '((type . dun-ftptype) (binary . dun-bin) (bin . dun-bin)
		      (send . dun-send) (put . dun-send) (quit . dun-ftpquit)
		      (help . dun-ftphelp)(ascii . dun-fascii)
		      ) line)
	     -1)
	    (dun-mprincl "No such command.  Try help.
î悤ȃR}h͂ȂB help ƁBj")))
      (setq dun-ftptype 'ascii)))

(defun dun-ftptype (args)
  (if (not (car args))
      (dun-mprincl "Usage: type [binary | ascii] igF type ubinary ܂ asciivj")
    (setq args (intern (car args)))
    (if (eq args 'binary)
	(dun-bin nil)
      (if (eq args 'ascii)
	  (dun-fascii 'nil)
	(dun-mprincl "Unknown type.isȃ^Cvj")))))

(defun dun-bin (args)
  (dun-mprincl "Type set to binary.i][hoCiɐݒj")
  (setq dun-ftptype 'binary))

(defun dun-fascii (args)
  (dun-mprincl "Type set to ascii.i][hAXL[ɐݒj")
  (setq dun-ftptype 'ascii))

(defun dun-ftpquit (args)
  (setq dun-exitf t))

(defun dun-send (args)
  (if (not (car args))
      (dun-mprincl "Usage: send <filename> igF send <t@C>j")
    (setq args (car args))
    (let (counter foo)
      (setq foo nil)
      (setq counter 0)

;;; User can send commands!  Stupid user.


      (if (assq (intern args) dun-unix-verbs)
	  (progn
	    (rplaca (assq (intern args) dun-unix-verbs) 'IMPOSSIBLE)
	    (dun-mprinc "Sending ")
	    (dun-mprinc dun-ftptype)
	    (dun-mprinc " file for ")
	    (dun-mprincl args)
	  (dun-mprincl (format "it@C %s  %s [hœ]Bj" 
		args dun-ftptype))
	    (dun-mprincl "Transfer complete.i]j"))

	(dolist (x dun-objfiles)
	  (if (string= args x)
	      (progn
		(if (not (member counter dun-inventory))
		    (progn
		      (dun-mprincl "No such file.î悤ȃt@C͂Ȃj")
		      (setq foo t))
		  (dun-mprinc "Sending ")
		  (dun-mprinc dun-ftptype)
		  (dun-mprinc " file for ")
		  (dun-mprinc (downcase (cadr (nth counter dun-objects))))
		  (dun-mprincl ", (0 bytes)")
	  (dun-mprincl (format "it@C %s  %s [hœ]Bj" 
		args dun-ftptype))
		  (if (not (eq dun-ftptype 'binary))
		      (progn
			(if (not (member obj-protoplasm
					 (nth receiving-room 
					      dun-room-objects)))
			    (dun-replace dun-room-objects receiving-room
				     (append (nth receiving-room 
						  dun-room-objects)
					     (list obj-protoplasm))))
			(dun-remove-obj-from-inven counter))
		    (dun-remove-obj-from-inven counter)
		    (dun-replace dun-room-objects receiving-room
			     (append (nth receiving-room dun-room-objects)
				     (list counter))))
		  (setq foo t)
		  (dun-mprincl "Transfer complete.i]j"))))
	  (setq counter (+ 1 counter)))
	(if (not foo)
	    (dun-mprincl "No such file."))))))

(defun dun-ftphelp (args)
  (dun-mprincl 
   "Possible commands are:\nsend    quit    type   ascii  binary   help
i\ȃR}h send M^quit I^ type ][hw^
    ascii ][h^ binary vO][h ^help g̕\j"))

(defun dun-uexit (args)
  (setq dungeon-mode 'dungeon)
  (dun-mprincl "\nȂ̓R\[։܂B")
  (define-key dungeon-mode-map "\r" 'dun-parse)
  (if (not dun-batch-mode)
      (dun-messages)))

(defun dun-pwd (args)
  (dun-mprincl dun-cdpath))

(defun dun-uncompress (args)
  (if (not (car args))
      (dun-mprincl "Usage: uncompress <filename>igF uncompress <t@C> j")
    (setq args (car args))
    (if (or dun-uncompressed
	    (and (not (string= args "paper.o"))
		 (not (string= args "paper.o.z"))))
	(dun-mprincl "Uncompress command failed.ikt@C̓WJR}hsj")
      (setq dun-uncompressed t)
      (setq dun-inventory (append dun-inventory (list obj-paper))))))

(defun dun-rlogin (args)
  (let (passwd)
    (if (not (car args))
	(dun-mprincl "Usage: rlogin <hostname> igF rlogin <Rs[^>j ")
      (setq args (car args))
      (if (string= args "endgame")
	  (dun-rlogin-endgame)
	(if (not (string= args "gamma"))
	    (if (string= args "pokey")
		(dun-mprincl "Can't rlogin back to localhost
iݎgpĂzXgrlogin邱Ƃ͂łȂj")
	      (dun-mprincl "No such host.î悤ȃzXg͂Ȃj"))
	  (if (not dun-ethernet)
	      (dun-mprincl "Host not responding.izXg牞Ȃj")
	    (dun-mprinc "PasswordipX[hj: ")
	    (setq passwd (dun-read-line))
	    (if (not (string= passwd "worms"))
		(dun-mprincl "\nlogin incorrectiOCsj")
	      (dun-mprinc 
"\n
Ȃ͈uAȊāAĂȂ͑SĂ̎܂B"
)
	      (dun-replace dun-room-objects computer-room 
		       (append (nth computer-room dun-room-objects) 
			       dun-inventory))
	      (setq dun-inventory nil)
	      (setq dun-current-room receiving-room)
	      (dun-uexit nil))))))))
  
(defun dun-cd (args)
  (let (tcdpath tcdroom path-elements room-check)
    (if (not (car args))
	(dun-mprincl "Usage: cd <path> igF cd <ړfBNg> j")
      (setq tcdpath dun-cdpath)
      (setq tcdroom dun-cdroom)
      (setq dun-badcd nil)
      (condition-case nil
	  (setq path-elements (dun-get-path (car args) nil))
	(error (dun-mprincl "Invalid path.isȃfBNgj")
	       (setq dun-badcd t)))
      (dolist (pe path-elements)
	      (unless dun-badcd
		      (if (not (string= pe "."))
			  (if (string= pe "..")
			      (progn
				(if (> tcdroom 0)                  ;In a room
				    (progn
				      (setq tcdpath "/rooms")
				      (setq tcdroom -2))
					;In /rooms,/usr,root
				  (if (or 
				       (= tcdroom -2) (= tcdroom -4) 
				       (= tcdroom -3))
				      (progn
					(setq tcdpath "/")
					(setq tcdroom -3))
				    (if (= tcdroom -10)       ;In /usr/toukmond
					(progn
					  (setq tcdpath "/usr")
					  (setq tcdroom -4))))))
			    (if (string= pe "/")
				(progn
				  (setq tcdpath "/")
				  (setq tcdroom -3))
			      (if (= tcdroom -4)
				  (if (string= pe "toukmond")
				      (progn
					(setq tcdpath "/usr/toukmond")
					(setq tcdroom -10))
				    (dun-nosuchdir))
				(if (= tcdroom -10)
				    (dun-nosuchdir)
				  (if (> tcdroom 0)
				      (dun-nosuchdir)
				    (if (= tcdroom -3)
					(progn
					  (if (string= pe "rooms")
					      (progn
						(setq tcdpath "/rooms")
						(setq tcdroom -2))
					    (if (string= pe "usr")
						(progn
						  (setq tcdpath "/usr")
						  (setq tcdroom -4))
					      (dun-nosuchdir))))
				      (if (= tcdroom -2)
					  (progn
					    (dolist (x dun-visited)
						    (setq room-check 
							  (nth x 
							      dun-room-shorts))
						    (if (string= room-check pe)
							(progn
							  (setq tcdpath 
						 (concat "/rooms/" room-check))
							  (setq tcdroom x))))
					    (if (= tcdroom -2)
						(dun-nosuchdir)))))))))))))
      (if (not dun-badcd)
	  (progn
	    (setq dun-cdpath tcdpath)
	    (setq dun-cdroom tcdroom)
	    0)
      -2))))

(defun dun-nosuchdir ()
  (dun-mprincl "No such directory.î悤ȃfBNg͂Ȃj")
  (setq dun-badcd t))

(defun dun-cat (args)
  (let (doto checklist)
    (if (not (setq args (car args)))
	(dun-mprincl "Usage: cat <ascii-file-name>igF cat <̓t@C> j")
      (if (string-match "/" args)
	  (dun-mprincl "cat: only files in current directory allowed.
icat:݂fBNg̃t@Ĉ݉{\j")
	(if (and (> dun-cdroom 0) (string= args "description"))
	    (dun-mprincl (car (nth dun-cdroom dun-rooms)))
	  (if (setq doto (string-match "\\.o" args))
	      (progn
		(if (= dun-cdroom -10)
		    (setq checklist dun-inventory)
		  (setq checklist (nth dun-cdroom dun-room-objects)))
		(if (not (member (cdr 
				  (assq (intern 
					 (substring args 0 doto)) 
					dun-objnames))
				 checklist))
		    (dun-mprincl "File not found.it@CȂj")
		  (dun-mprincl "Ascii files only.it@Ĉ݉{\j")))
	    (if (assq (intern args) dun-unix-verbs)
		(dun-mprincl "Ascii files only.it@Ĉ݉{\j")
	      (dun-mprincl "File not found.it@CȂj"))))))))
  
(defun dun-zippy (args)
  (dun-mprincl (yow)))

(defun dun-rlogin-endgame ()
  (if (not (= (dun-score nil) 90))
;  (if (not (= (dun-score nil) 70))
      (dun-mprincl 
       "You have not achieved enough points to connect to endgame.
iȂendgameɐڑ̂ɏ\ȓ_܂lĂ܂Bj")
    (dun-mprincl"\nendgameւ悤BȂ͂ƂĂC`ƂłB")
    (setq dun-current-room treasure-room)
    (setq dun-endgame t)
    (dun-replace dun-room-objects endgame-treasure-room (list obj-bill))
    (dun-uexit nil)))


(random t)
(setq tloc (+ 60 (random 18)))
(dun-replace dun-room-objects tloc 
	     (append (nth tloc dun-room-objects) (list 18)))

(setq tcomb (+ 100 (random 899)))
(setq dun-combination (prin1-to-string tcomb))

;;;;
;;;; This section defines the DOS emulation functions for dunnet
;;;;

(defun dun-dos-parse (args)
  (interactive "*p")
  (beginning-of-line)
  (let (beg)
    (setq beg (+ (point) 3))
    (end-of-line)
    (if (not (= beg (point)))
	(let (line)
	  (setq line (downcase (buffer-substring beg (point))))
	  (princ line)
	  (if (eq (dun-parse2 nil dun-dos-verbs line) -1)
	      (progn
		(sleep-for 1)
		(dun-mprincl "Bad command or file name isȖ߂܂̓t@Cj"))))
      (goto-char (point-max))
      (dun-mprinc "\n"))
    (if (eq dungeon-mode 'dos)
	(progn
	  (dun-fix-screen)
	  (dun-dos-prompt)))))

(defun dun-dos-interface ()
  (dun-dos-boot-msg)
  (setq dungeon-mode 'dos)
  (define-key dungeon-mode-map "\r" 'dun-dos-parse)
  (dun-dos-prompt))

(defun dun-dos-type (args)
  (sleep-for 2)
  (if (setq args (car args))
      (if (string= args "foo.txt")
	  (dun-dos-show-combination)
	(if (string= args "command.com")
	    (dun-mprincl "Cannot type binary filesioCit@C͕sj")
	  (dun-mprinc "File not found - ")
	  (dun-mprincl (upcase args))
	  (dun-mprincl (format "it@C %s Ȃj" (upcase args)))
	))
    (dun-mprincl "Must supply file name")))

(defun dun-dos-invd (args)
  (sleep-for 1)
  (dun-mprincl "Invalid drive specification ĩhCu݂͑Ȃj"))

(defun dun-dos-dir (args)
  (sleep-for 1)
  (if (or (not (setq args (car args))) (string= args "\\"))
      (dun-mprincl "
 Volume in drive A is FOO        
 Volume Serial Number is 1A16-08C9
 Directory of A:\\

COMMAND  COM     47845 04-09-91   2:00a
FOO      TXT        40 01-20-93   1:01a
        2 file(s)      47845 bytes
                     1065280 bytes free
")
    (dun-mprincl "
 Volume in drive A is FOO        
 Volume Serial Number is 1A16-08C9
 Directory of A:\\

File not found")))


(defun dun-dos-prompt ()
  (dun-mprinc "A> "))

(defun dun-dos-boot-msg ()
  (sleep-for 3)
  (dun-mprinc "Current time is ")
  (dun-mprincl (substring (current-time-string) 12 20))
  (dun-mprincl (format "i݂̎ %s j" (substring (current-time-string) 12 20)))
  (dun-mprinc "Enter new timei͂j: ")
  (dun-read-line)
  (if (not dun-batch-mode)
      (dun-mprinc "\n")))

(defun dun-dos-spawn (args)
  (sleep-for 1)
  (dun-mprincl "Cannot spawn subshell"))

(defun dun-dos-exit (args)
  (setq dungeon-mode 'dungeon)
  (dun-mprincl "\nȂ̓p\R̓d𗎂ƂėꂽB")
  (define-key dungeon-mode-map "\r" 'dun-parse)
  (if (not dun-batch-mode)
      (dun-messages)))

(defun dun-dos-no-disk ()
  (sleep-for 3)
  (dun-mprincl "Boot sector not found iNɕKvȏ񂪌Ȃj"))


(defun dun-dos-show-combination ()
  (sleep-for 2)
  (dun-mprinc "\nThe combination is ")
  (dun-mprinc dun-combination)
  (dun-mprinc ".")
  (dun-mprinc (format "igݍ킹 %s łBj\n" dun-combination)) )

(defun dun-dos-nil (args))


;;;;
;;;; This section defines the save and restore game functions for dunnet.
;;;;

(defun dun-save-game (filename)
  (if (not (setq filename (car filename)))
      (dun-mprincl "Q[ۑɂ save ̌ɕۑt@C^Kv܂B
iJgfBNgɎw肵Õt@C܂j")
    (if (file-exists-p filename)
	(delete-file filename))
    (setq dun-numsaves (1+ dun-numsaves))
    (dun-make-save-buffer)
    (dun-save-val "dun-current-room")
    (dun-save-val "dun-computer")
    (dun-save-val "dun-combination")
    (dun-save-val "dun-visited")
    (dun-save-val "dun-diggables")
    (dun-save-val "dun-key-level")
    (dun-save-val "dun-floppy")
    (dun-save-val "dun-numsaves")
    (dun-save-val "dun-numcmds")
    (dun-save-val "dun-logged-in")
    (dun-save-val "dungeon-mode")
    (dun-save-val "dun-jar")
    (dun-save-val "dun-lastdir")
    (dun-save-val "dun-black")
    (dun-save-val "dun-nomail")
    (dun-save-val "dun-unix-verbs")
    (dun-save-val "dun-hole")
    (dun-save-val "dun-uncompressed")
    (dun-save-val "dun-ethernet")
    (dun-save-val "dun-sauna-level")
    (dun-save-val "dun-room-objects")
    (dun-save-val "dun-room-silents")
    (dun-save-val "dun-inventory")
    (dun-save-val "dun-endgame-questions")
    (dun-save-val "dun-endgame")
    (dun-save-val "dun-cdroom")
    (dun-save-val "dun-cdpath")
    (dun-save-val "dun-correct-answer")
    (dun-save-val "dun-inbus")
    (dun-save-val "dun-question-message")
    (if (dun-compile-save-out filename)
	(dun-mprincl "Q[t@CɕۑۂɃG[܂B")
      (dun-do-logfile 'save nil)
      (switch-to-buffer "*dungeon*")
      (princ "")
      (dun-mprincl "Q[̏Ԃۑ܂B"))))

(defun dun-make-save-buffer ()
  (switch-to-buffer (get-buffer-create "*save-dungeon*"))
  (erase-buffer))

(defun dun-compile-save-out (filename)
  (let (ferror)
    (setq ferror nil)
    (condition-case nil
	(dun-rot13)
      (error (setq ferror t)))
    (if (not ferror)
	(progn
	  (goto-char (point-min))))
    (condition-case nil
        (write-region 1 (point-max) filename nil 1)
        (error (setq ferror t)))
    (kill-buffer (current-buffer))
    ferror))
    

(defun dun-save-val (varname)
  (let (value)
    (setq varname (intern varname))
    (setq value (eval varname))
    (dun-minsert "(setq ")
    (dun-minsert varname)
    (dun-minsert " ")
    (if (or (listp value)
	    (symbolp value))
	(dun-minsert "'"))
    (if (stringp value)
	(dun-minsert "\""))
    (dun-minsert value)
    (if (stringp value)
	(dun-minsert "\""))
    (dun-minsertl ")")))


(defun dun-restore (args)
  (let (file)
    (if (not (setq file (car args)))
	(dun-mprincl "Q[ĊJɂ restore ̌Ƀt@C^Kv܂B")
      (if (not (dun-load-d file))
	  (dun-mprincl "t@CǂނƂł܂B")
	(dun-mprincl "Q[̓rĊJ܂B")
	(setq room 0)))))


(defun dun-do-logfile (type how)
  (let (ferror newscore)
    (setq ferror nil)
    (switch-to-buffer (get-buffer-create "*score*"))
    (erase-buffer)
    (condition-case nil
	(insert-file-contents dun-log-file)
      (error (setq ferror t)))
    (unless ferror
	    (goto-char (point-max))
	    (dun-minsert (current-time-string))
	    (dun-minsert " ")
	    (dun-minsert (user-login-name))
	    (dun-minsert " ")
	    (if (eq type 'save)
		(dun-minsert "saved ")
	      (if (= (dun-endgame-score) 110)
		  (dun-minsert "won ")
		(if (not how)
		    (dun-minsert "quit ")
		  (dun-minsert "killed by ")
		  (dun-minsert how)
		  (dun-minsert " "))))
	    (dun-minsert "at ")
	    (dun-minsert (cadr (nth (abs room) dun-rooms)))
	    (dun-minsert ". score: ")
	    (if (> (dun-endgame-score) 0)
		(dun-minsert (setq newscore (+ 90 (dun-endgame-score))))
	      (dun-minsert (setq newscore (dun-reg-score))))
	    (dun-minsert " saves: ")
	    (dun-minsert dun-numsaves)
	    (dun-minsert " commands: ")
	    (dun-minsert dun-numcmds)
	    (dun-minsert "\n")
	    (write-region 1 (point-max) dun-log-file nil 1))
    (kill-buffer (current-buffer))))


;;;;
;;;; These are functions, and function re-definitions so that dungeon can
;;;; be run in batch mode.


(defun dun-batch-mprinc (arg)
   (if (stringp arg)
       (send-string-to-terminal arg)
     (send-string-to-terminal (prin1-to-string arg))))


(defun dun-batch-mprincl (arg)
   (if (stringp arg)
       (progn
           (send-string-to-terminal arg)
           (send-string-to-terminal "\n"))
     (send-string-to-terminal (prin1-to-string arg))
     (send-string-to-terminal "\n")))

(defun dun-batch-parse (dun-ignore dun-verblist line)
  (setq line-list (dun-listify-string (concat line " ")))
  (dun-doverb dun-ignore dun-verblist (car line-list) (cdr line-list)))

(defun dun-batch-parse2 (dun-ignore dun-verblist line)
  (setq line-list (dun-listify-string2 (concat line " ")))
  (dun-doverb dun-ignore dun-verblist (car line-list) (cdr line-list)))

(defun dun-batch-read-line ()
  (read-from-minibuffer "" nil dungeon-batch-map))


(defun dun-batch-loop ()
  (setq dun-dead nil)
  (setq room 0)
  (while (not dun-dead)
    (if (eq dungeon-mode 'dungeon)
	(progn
	  (if (not (= room dun-current-room))
	      (progn
		(dun-describe-room dun-current-room)
		(setq room dun-current-room)))
	  (dun-mprinc ">")
	  (setq line (downcase (dun-read-line)))
	  (if (eq (dun-vparse dun-ignore dun-verblist line) -1)
	      (dun-mprinc "I don't understand that.\n"))))))

(defun dun-batch-dos-interface ()
  (dun-dos-boot-msg)
  (setq dungeon-mode 'dos)
  (while (eq dungeon-mode 'dos)
    (dun-dos-prompt)
    (setq line (downcase (dun-read-line)))
    (if (eq (dun-parse2 nil dun-dos-verbs line) -1)
	(progn
	  (sleep-for 1)
	  (dun-mprincl "Bad command or file name"))))
  (goto-char (point-max))
  (dun-mprinc "\n"))

(defun dun-batch-unix-interface ()
    (dun-login)
    (if dun-logged-in
	(progn
	  (setq dungeon-mode 'unix)
	  (while (eq dungeon-mode 'unix)
	    (dun-mprinc "$ ")
	    (setq line (downcase (dun-read-line)))
	    (if (eq (dun-parse2 nil dun-unix-verbs line) -1)
		(let (esign)
		  (if (setq esign (string-match "=" line))
		      (dun-doassign line esign)		
		    (dun-mprinc (car line-list))
		    (dun-mprincl ": not found.")))))
	  (goto-char (point-max))
	  (dun-mprinc "\n"))))

(defun dungeon-nil (arg)
  "noop"
  (interactive "*p")
  nil)

(defun dun-batch-dungeon ()
  (load "dun-batch")
  (setq dun-visited '(27))
  (dun-mprinc "\n")
  (dun-batch-loop))

(unless (not noninteractive)
  (fset 'dun-mprinc 'dun-batch-mprinc)
  (fset 'dun-mprincl 'dun-batch-mprincl)
  (fset 'dun-vparse 'dun-batch-parse)
  (fset 'dun-parse2 'dun-batch-parse2)
  (fset 'dun-read-line 'dun-batch-read-line)
  (fset 'dun-dos-interface 'dun-batch-dos-interface)
  (fset 'dun-unix-interface 'dun-batch-unix-interface)
  (dun-mprinc "\n")
  (setq dun-batch-mode t)
  (dun-batch-loop))

(provide 'dunnet)

;; dunnet.el ends here

